/*
 * a1-i.j.c
 * Copyright (C) 2011-2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <a1-types.h>
#include <af.h>
#include <lxcall.h>

int
_x1f4_a1_suit_node(struct center_type *center_data,
		   struct covert_type *covert_data, void *data,
		   int type)
{
    int status;

    if (X1f4_E4_CALL < type) {
	status = _libx1f4i0_lxcall_pick_deck
	    (covert_data->frame_data, center_data->track_data,
	     _x1f4_lead_effect, _x1f4_slip_effect, NULL,
	     *(void **) data, data);
    } else {
	const char *name;
	struct a1_shuffle_type *shuffle_data;
	const struct x1f4_datatype_type *datatype_data;

	shuffle_data = covert_data->text;

	datatype_data = shuffle_data->u.datatype_data;
	name = datatype_data->name;
	while (name) {
	    if (datatype_data->type == type) {
		break;
	    } else {
		datatype_data++;
		name = datatype_data->name;
	    }
	}
	if (name) {
	} else {
	    datatype_data = shuffle_data->u.sidetype_data;
	    name = datatype_data->name;
	    while (name) {
		if (datatype_data->type == type) {
		    break;
		} else {
		    datatype_data++;
		    name = datatype_data->name;
		}
	    }
	}

	if (name) {
	    if (datatype_data->lead) {
		status = _libx1f4i0_lxcall_line_node
		    (covert_data->frame_data, center_data->track_data,
		     (void *) datatype_data, data);
	    } else {
		status = 0;
	    }
	} else {
	    status = 0;
	}

	return status;
    }

    return status;
}
