/*
 * af.d.c
 * Copyright (C) 2014, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <a1n.h>
#include <e4.h>
#include <ln.h>
#include <nt.h>

int
_x1f4_dump_effect(void *subtext, struct x1f4_nodelink_type *nodelink_data)
{
    int status;
    unsigned flags;

    flags = ((const struct x1f4_linetext_type *)
	     ((char *) nodelink_data
	      - offsetof(struct x1f4_leadnode_type, link)
	      + sizeof(struct x1f4_leadnode_type)))->function.flags;

    if (flags & X1f4_E4_NODE_LINK) {
	status = _x1f4_a1_dump_news(subtext, nodelink_data);
    } else {
	if (flags & X1f4_E4_OVER_LINK) {
	    struct x1f4_leadnode_type *leadnode_data;
	    struct x1f4_nodetype_type *nodetype_data;

	    leadnode_data = (void *)
		((char *) nodelink_data
		 - offsetof(struct x1f4_leadnode_type, link));
	    leadnode_data--;

	    nodetype_data = leadnode_data->link.nodetype_data;

	    status = nodetype_data->dump
		(nodetype_data->context, nodelink_data);
	} else {
	    /*
	     * possibly unreached
	     */
	    status = 0;
	}
    }

    return status;
}
