/*
 * bqfv.e.c
 * Copyright (C) 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bqfx-config.h>

#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include <bqfx-bits.h>
#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-lines.h>
#include <bqfx-names.h>
#include <bqfx-types.h>
#include <kfs.h>
#include <kls.h>

#define false(e)			0
#define true(e)				1

#define beta(___s, ___n) \
    (___s) = (char *) (___s) - ((___n) << 1)

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

static int aeon(void *, void *, unsigned, unsigned, unsigned,
	        int (*)(void *, void *, unsigned));
static int arch(void *, void *, unsigned, unsigned,
	        int (*)(void *, void *, unsigned));
static int call(void *, void *, unsigned, void *, void *, void *);
static int ever(void *, void *, unsigned *);
static int head(void *, void *, unsigned, void *);
static int keel(void *, void *, unsigned, void *, void *, void *);
static int lead(void *, void *, unsigned *);
static int lift(void *, void *, unsigned, unsigned, void *, void **, void **);
static int mint(void *, void *, unsigned, unsigned, void *, void **, void **);
static int peel(void *, void *, unsigned, void *);
static int poll(void *, void *, unsigned, void *);
static int reel(void *, void *, unsigned, void *, void *);
static int rift(void *, void *, unsigned, unsigned, void *, void **, void **);
static int roll(void *, void *, unsigned, void *, void *);
static int seal(void *, void *, unsigned, void *, void *, void *, void *);
static int sole(void *, void *, unsigned, void *, void *, void *, void *);
static int spin(void *, void *, unsigned, unsigned, void *, void **, void **);
static int tail(void *, void *, unsigned, void *);
static int wrap(void *, void *, void *);
static int yank(void *, void *);

static int
aeon(void *call, void *data, unsigned copy, unsigned rend, unsigned size,
     int (*move)(void *, void *, unsigned))
{
    unsigned i, sink;
    void **iran, **pull;

    copy -= integral_q_line;

    sink = half_integral_q_bits - copy;

    *((integral_q *) call) = Lx55555555 | (~Q(0) >> sink >> sink);

    iran = ZD(call, size);
    pull = MD(data, size) + rend;

    if (sink) {
    } else {
	copy--;
    }

    {
	skip(call, size);
	data = rule(data, size, 1 + rend);
    }

    i = copy;
    for (; i; i--) {
	move(call, data, 2);
	dana(call, size);
	dana(data, size);
	*iran++ = *pull++;
	*iran++ = *pull++;
    }
    i = sink;
    if (i) {
	skip(call, size);
	iran++;
	*iran = *pull++;
	i--;
    } else {
	i = 1;
	*iran = *pull++;
	iran--;
    }
    for (; i; i--) {
	move(call, data, 1);
	dana(call, size);
	skip(data, size);
	iran += 2;
	*iran = *pull++;
    }

    return 0;
}


static int
arch(void *call, void *data, unsigned copy, unsigned size,
     int (*move)(void *, void *, unsigned))
{
    unsigned i, sink;

    copy -= integral_q_line;

    sink = half_integral_q_bits - copy;

    *((integral_q *) call) = Lx55555555 | (~Q(0) >> sink >> sink);

    if (sink) {
    } else {
	copy--;
    }

    {
	skip(call, size);
    }

    i = copy;
    for (; i; i--) {
	move(call, data, 2);
	dana(call, size);
	dana(data, size);
    }
    i = sink;
    if (i) {
	skip(call, size);
	i--;
    } else {
	i = 1;
    }
    for (; i; i--) {
	move(call, data, 1);
	dana(call, size);
	skip(data, size);
    }

    return 0;
}


static int
call(void *bqfset, void *tier, unsigned pick, void *file, void *park,
     void *side)
{
    int (*move)(void *, void *, unsigned);
    integral_q news;
    unsigned i, j, size;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    *((integral_q *) side) = Lx55555555;

    i = pick;
    for (; i; i--) {
	dana(side, size);
	skip(file, size);
	move(side, file, 1);
    }

    news = *(integral_q *) tier;

    file = tier;

    i = integral_q_line - pick;
    j = 1;

    do {
	if (i) {
	    if (news & Q(1) << j) {
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		i--;
	    } else {
		dana(file, size);
	    }

	    j += 2;
	} else {
	    if (news & Q(1) << j) {
		skip(file, size);
		move(park, file, 1);

		break;
	    } else {
		dana(file, size);
		goto mend;
	    }
	}

	while (1 < i) {
	    if (news & Q(1) << j) {
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		i -= 2;
	    } else {
		dana(side, size);
		move(side, file, 1);
		dana(file, size);
		i--;
	    }

	    j += 2;
	}

	if (i) {
	    if (news & Q(1) << j) {
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		move(park, file, 1);
		skip(file, size);
	    } else {
		dana(side, size);
		move(side, file, 1);
		dana(file, size);
	    }
	} else {
	    j -= 2;
	}

    mend:
	side = tier;

	if (i && news & Q(1) << j) {
	} else {
	    j += 2;

	    if (news & Q(1) << j) {
		move(park, file, 1);
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
	    } else {
		move(park, file, 1);
		dana(file, size);
	    }
	}

	dana(side, size);

	while (file != side) {
	    j += 2;

	    if (news & Q(1) << j) {
		move(side, file, 1);
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
	    } else {
		move(side, file, 1);
		dana(file, size);
	    }

	    dana(side, size);
	}
    } while (0);

    *((integral_q *) tier) = news & ~Q(1) << j | Lx55555555;

    return 0;
}


static int
ever(void *bqtext, void *turn, unsigned *rate)
{
    int status;
    void *trip;

    _libx1f4l2_ever_bqfset(bqtext, &trip);

    status = bqfset(bqtext)->link_f.move(turn, trip, 1);
    if (status) {
	status = MOVE_ERROR;
    } else {
	status = _libx1f4l2_slip_bqfset(bqtext);
	if (status) {
	} else {
	    *rate = bqfset(bqtext)->link_a.fpnews.link_v.rate;
	    if (*rate) {
	    } else {
		status = _libx1f4l2_post_bqfset(bqtext, turn, &trip);
		if (status) {
		} else {
		    status = bqfset(bqtext)->link_f.move(trip, turn, 1);
		    if (status) {
			status = MOVE_ERROR;
		    }
		}
	    }
	}
    }

    return status;
}


static int
head(void *bqdata, void *bqtext, unsigned late, void *turn)
{
    int status = 0;
    unsigned size;
    void *data;

    size = bqfset(bqtext)->link_a.fpnews.link_v.size;

head:
    do {
	int (*move)(void *, void *, unsigned);
	unsigned copy = -1, diff, rate, mind;
	void *text, *file;

	rate = bqfset(bqtext)->link_a.fpnews.link_v.rate;

	text = bqfset(bqtext)->link_a.fpnews.node;

	mind = *(integral_q *) text;

	diff = rate - late - 1;

	data = bqfset(bqdata)->link_a.fpnews.node;

	if (mind ^ (integral_q_bits_and_half - 1)) {
	} else {
	    status = _libx1f4l2_long_bqfset(bqtext, sans(data, size), NULL);
	    if (status) {
		break;
	    } else {
		goto head;
	    }
	}

	file = MD(text, size)[0];

	for (--rate; rate ^ late; rate--) {
	    integral_q news;

	    if (~*(integral_q *) file) {
	    } else {
		if (rate + 1 == bqfset(bqtext)->link_a.fpnews.link_v.rate) {
		    status = _libx1f4l2_hale_bqfset
			(bqtext, text, 0, &file, sans(data, size), NULL);
		} else {
		    status = _libx1f4l2_fare_bqfset
			(bqtext, text, copy, &file, rate + 1, sans(data, size),
			 NULL);
		}
		if (status) {
		    break;
		}
	    }

	    text = file;

	    news = *(integral_q *) file;
	    file = ZD(text, size)[copy = ~news >> 1 & 1];
	}

	copy = *(integral_q *) data;

	move = bqfset(bqtext)->link_f.move;

	if (late) {
	    if (copy < integral_q_line) {
		unsigned ever;

		bq_q_bitcount(ever, ~*(integral_q *) file);
		if (copy < ever) {
		    status = roll(bqtext, file, copy, turn, data);
		} else {
		    void *park, *side;

		    status = (diff ? mint : lift)
			(bqtext, text, size, SIZEOF_integral_q + size, NULL,
			 &park, &side);
		    if (status) {
			break;
		    } else {
			status = sole
			    (bqtext, file, copy, turn, data, park, side);
		    }
		}
	    } else {
		void *side;

		status = (diff ? mint : lift)
		    (bqtext, text, size, SIZEOF_integral_q + size, turn, NULL,
		     &side);
		if (status) {
		    break;
		}

		if (copy < integral_q_bits) {
		    aeon(side, data, copy, 0, size, move);
		} else {
		    unsigned rend;

		    rend = copy >> 1;

		    copy -= rend;

		    aeon(side, data, rend, copy, size, move);

		    status = (diff ? mint : lift)
			(bqtext, text, size, SIZEOF_integral_q + size,
			 rule(data, size, copy), NULL, &side);
		    if (status) {
			*((integral_q *) data) = copy - 1;
			move(turn, rule(data, size, copy), 1);

			if (status == PLAN_RERUN) {
			    goto head;
			} else {
			    break;
			}
		    } else {
			aeon(side, data, copy - 1, 0, size, move);
		    }
		}
	    }
	} else {
	    if (copy < half_integral_q_bits) {
		unsigned ever;

		bq_q_bitcount(ever, ~*(integral_q *) file);
		if (ever < copy) {
		    void *park, *side;

		    status = (diff ? mint : lift)
			(bqtext, text, size, size, NULL, &park, &side);
		    if (status) {
			break;
		    } else {
			status = call(bqtext, file, copy, data, park, side);
		    }
		} else {
		    if (copy) {
			status = poll(bqtext, file, copy, data);
		    }
		}
	    } else {
		void *side;

		skip(data, size);

		copy--;

		status = (diff ? mint : lift)
		    (bqtext, text, size, size, rule(data, size, copy), NULL,
		     &side);
		if (status) {
		    break;
		}

		if (copy < integral_q_bits) {
		    arch(side, data, copy, size, move);
		} else {
		    unsigned rend;

		    rend = copy >> 1;

		    copy -= rend;

		    arch(side, rule(data, size, copy), rend, size, move);

		    copy--;

		    status = (diff ? mint : lift)
			(bqtext, text, size, size, rule(data, size, copy),
			 NULL, &side);
		    if (status) {
			side = bqfset(bqdata)->link_a.fpnews.node;
			*((integral_q *) side) = copy + 1;

			if (status == PLAN_RERUN) {
			    goto head;
			} else {
			    break;
			}
		    } else {
			arch(side, data, copy, size, move);
		    }
		}
	    }
	}
    } while (0);

    if (status) {
    } else {
	bqfset(bqdata)->link_a.fpnews.link_v.rate = 0;

	data = bqfset(bqdata)->link_a.fpnews.node;

	*((integral_q *) data) = 0;

#if __MICRO_FSETS__
	status = bqfset(bqtext)->link_m.mode
	    (bqfset(bqtext)->link_m.data, &data, 3 * size);
	if (status) {
	    status = MODE_ERROR;
	} else {
	    bqfset(bqdata)->link_a.fpnews.node = data;
	}
#endif				/* __MICRO_FSETS__ */
    }

    return status;
}


static int
keel(void *bqfset, void *club, unsigned pick, void *file, void *park,
     void *side)
{
    int (*move)(void *, void *, unsigned);
    integral_q news;
    unsigned i, j, size;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    side = rule(side, size, integral_q_bits);

    file = rule(file, size, pick);

    i = pick;
    for (; i; i--) {
	beta(side, size);
	move(side, file, 1);
	posh(file, size);
    }

    news = *(integral_q *) club;

    file = rule(club, size, integral_q_bits);

    i = integral_q_line - pick;
    j = integral_q_last;

    while (1 < i) {
	if (news & Q(1) << j) {
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    i -= 2;
	} else {
	    beta(side, size);
	    beta(file, size);
	    move(side, file, 1);
	    i--;
	}

	j -= 2;
    }

    if (i) {
	if (news & Q(1) << j) {
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    posh(file, size);
	    move(park, file, 1);
	} else {
	    beta(side, size);
	    beta(file, size);
	    move(side, file, 1);
	}
    } else {
	j += 2;
    }

    beta(side, size);
    *((integral_q *) side) = Lx55555555;

    side = rule(club, size, integral_q_bits);

    if (i && news & Q(1) << j) {
    } else {
	j -= 2;

	if (news & Q(1) << j) {
	    posh(file, size);
	    move(park, file, 1);
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	} else {
	    beta(file, size);
	    move(park, file, 1);
	}
    }

    while (file != side) {
	j -= 2;

	if (news & Q(1) << j) {
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	} else {
	    beta(side, size);
	    beta(file, size);
	    move(side, file, 1);
	}
    }

    *((integral_q *) club) = news & (Q(1) << j) - 1 | Lx55555555;

    return 0;
}


static int
lead(void *bqtext, void *turn, unsigned *rate)
{
    int status;
    void *trip;

    _libx1f4l2_lead_bqfset(bqtext, &trip);

    status = bqfset(bqtext)->link_f.move(turn, trip, 1);
    if (status) {
	status = MOVE_ERROR;
    } else {
	status = _libx1f4l2_mind_bqfset(bqtext);
	if (status) {
	} else {
	    *rate = bqfset(bqtext)->link_a.fpnews.link_v.rate;
	    if (*rate) {
	    } else {
		status = _libx1f4l2_post_bqfset(bqtext, turn, &trip);
		if (status) {
		} else {
		    status = bqfset(bqtext)->link_f.move(trip, turn, 1);
		    if (status) {
			status = MOVE_ERROR;
		    }
		}
	    }
	}
    }

    return status;
}


static int
lift(void *bqfset, void *data, unsigned size, unsigned unit, void *text,
     void **park, void **plus)
{
    int status;

    do {
	unsigned copy;

	copy = *(integral_q *) data + 1;

	if (copy == integral_q_bits_and_half) {
	    status = PLAN_RERUN;
	    break;
	}

	status = bqfset(bqfset)->link_m.link
	    (bqfset(bqfset)->link_m.data, plus, integral_q_bits * unit);
	if (status) {
	    status = LINK_ERROR;
	} else {
	    void **iran;

	    *((integral_q *) data) = copy;

	    iran = MD(data, size);

	    skip(data, size);

	    bqfset(bqfset)->link_f.move(sans(data, size), data, copy - 1);

	    memmove(iran + 1, iran, sizeof(void *) * copy);

	    *iran = *plus;

	    if (park) {
		*park = data;
	    } else {
		bqfset(bqfset)->link_f.move(data, text, 1);
	    }
	}
    } while (0);

    return status;
}


static int
mint(void *bqfset, void *data, unsigned size, unsigned unit, void *text,
     void **park, void **plus)
{
    int status;

    do {
	integral_q news;

	news = *(integral_q *) data;

	if (~news) {
	} else {
	    status = PLAN_RERUN;
	    break;
	}

	status = bqfset(bqfset)->link_m.link
	    (bqfset(bqfset)->link_m.data, plus, integral_q_bits * unit);
	if (status) {
	    status = LINK_ERROR;
	} else {
	    unsigned i = 1, l;
	    void **iran;

	    for (; news & Q(1) << i; i += 2);

	    *((integral_q *) data) = news | Q(1) << i;

	    l = i - 1;

	    iran = ZD(data, size);

	    skip(data, size);

	    bqfset(bqfset)->link_f.move(sans(data, size), data, l);

	    iran += i - 1;
	    for (; l; l--) {
		*iran = *(iran - 1);
		iran--;
	    }
	    {
		*iran = *plus;
	    }

	    if (park) {
		*park = data;
	    } else {
		bqfset(bqfset)->link_f.move(data, text, 1);
	    }
	}
    } while (0);

    return status;
}


static int
peel(void *bqfset, void *club, unsigned pick, void *file)
{
    int (*move)(void *, void *, unsigned);
    integral_q news, seek;
    unsigned i, late, size;
    void *fast, *side;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    /*
     * stuffing pick:
     */
    late = pick - 1;
    l2_q_jls(i, ~*(integral_q *) club, late);
    i ^= 63;
    late = i;

    news = *(integral_q *) club;

    fast = rule(club, size, i);
    side = fast;
    seek = news >> i;
    if (true(i & 1)) {
	if (false(news & Q(1) << i)) {
	} else {
	    skip(side, size);
	}

	i++;
	seek >>= 1;
    }
    for (; seek; seek >>= 2) {
	if (seek & Q(2)) {
	    move(fast, side, 1);
	    skip(fast, size);
	    skip(side, size);
	    move(fast, side, 1);
	    skip(fast, size);
	    skip(side, size);
	} else {
	    move(fast, side, 1);
	    skip(fast, size);
	    dana(side, size);
	}
    }

    side = sans(file, size);

    i = pick;
    for (; i; i--) {
	move(fast, side, 1);
	skip(fast, size);
	skip(side, size);
    }

    *(integral_q *) club = news | (~Q(0) << late);

    return 0;
}


static int
poll(void *bqfset, void *tier, unsigned pick, void *file)
{
    int (*move)(void *, void *, unsigned);
    integral_q news, seek;
    unsigned i, late, size;
    void *fast, *side;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    /*
     * stuffing pick:
     */
    late = pick;
    l2_q_jfs(i, ~(*(integral_q *) tier & ~1), late);
    late = i;

    news = *(integral_q *) tier;

    fast = rule(tier, size, i + 1);
    side = fast;
    seek = (news & ~Q(3)) << (integral_q_last - i);
    for (; seek; seek <<= 2) {
	if (seek & Q(1) << integral_q_last) {
	    posh(fast, size);
	    posh(side, size);
	    move(fast, side, 1);
	    posh(fast, size);
	    posh(side, size);
	    move(fast, side, 1);
	} else {
	    posh(fast, size);
	    beta(side, size);
	    move(fast, side, 1);
	}
    }
    {
	if (news & 2) {
	    posh(fast, size);
	    posh(side, size);
	    move(fast, side, 1);
	} else {
	}
    }

    side = rule(file, size, pick);

    i = pick;
    for (; i; i--) {
	posh(fast, size);
	move(fast, side, 1);
	posh(side, size);
    }

    *(integral_q *) tier = news | ((Q(2) << late) - 1);

    return 0;
}


static int
reel(void *bqfset, void *club, unsigned pick, void *head, void *file)
{
    int (*move)(void *, void *, unsigned);
    integral_q news, seek;
    unsigned i, late, size;
    void **data, *fast, *side, **text;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    /*
     * stuffing pick + 1:
     */
    late = pick;
    l2_q_jls(i, ~*(integral_q *) club, late);
    i ^= 63;
    late = i;

    news = *(integral_q *) club;

    fast = rule(club, size, i);
    side = fast;
    data = ZD(club, size) + i;
    text = data;
    seek = news >> i;
    if (true(i & 1)) {
	if (false(news & Q(1) << i)) {
	} else {
	    skip(side, size);
	    *(data - 1) = *text;
	    text++;
	}

	i++;
	seek >>= 1;
    }
    for (; seek; seek >>= 2) {
	if (seek & Q(2)) {
	    move(fast, side, 1);
	    skip(fast, size);
	    skip(side, size);
	    move(fast, side, 1);
	    skip(fast, size);
	    skip(side, size);
	    *data++ = *text++;
	    *data++ = *text++;
	} else {
	    move(fast, side, 1);
	    skip(fast, size);
	    dana(side, size);
	    *data++ = *(text + 1);
	    text += 2;
	}
    }

    text = MD(file, size);

    move(fast, head, 1);
    skip(fast, size);
    *data++ = *text++;

    side = sans(file, size);

    i = pick;
    for (; i; i--) {
	move(fast, side, 1);
	skip(fast, size);
	skip(side, size);
	*data++ = *text++;
    }

    *(integral_q *) club = news | (~Q(0) << late);

    return 0;
}


static int
rift(void *bqfset, void *data, unsigned size, unsigned unit, void *text,
     void **park, void **plus)
{
    int status;

    do {
	unsigned copy;

	copy = *(integral_q *) data + 1;

	if (copy == integral_q_bits_and_half) {
	    status = PLAN_RERUN;
	    break;
	}

	status = bqfset(bqfset)->link_m.link
	    (bqfset(bqfset)->link_m.data, plus, integral_q_bits * unit);
	if (status) {
	    status = LINK_ERROR;
	} else {
	    *((integral_q *) data) = copy;

	    MD(data, size)[copy] = *plus;

	    data = rule(data, size, copy);
	    if (park) {
		*park = data;
	    } else {
		bqfset(bqfset)->link_f.move(data, text, 1);
	    }
	}
    } while (0);

    return status;
}


static int
roll(void *bqfset, void *tier, unsigned pick, void *past, void *file)
{
    int (*move)(void *, void *, unsigned);
    integral_q news, seek;
    unsigned i, late, size;
    void **data, *fast, *side, **text;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    /*
     * stuffing pick + 1:
     */
    late = pick + 1;
    l2_q_jfs(i, ~(*(integral_q *) tier & ~1), late);
    late = i;

    news = *(integral_q *) tier;

    fast = rule(tier, size, i + 1);
    side = fast;
    data = ZD(tier, size) + i + 1;
    text = data;
    seek = (news & ~Q(3)) << (integral_q_last - i);
    for (; seek; seek <<= 2) {
	if (seek & Q(1) << integral_q_last) {
	    beta(fast, size);
	    beta(side, size);
	    move(fast, side, 2);
	    *--data = *--text;
	    *--data = *--text;
	} else {
	    posh(fast, size);
	    beta(side, size);
	    move(fast, side, 1);
	    *--data = *(text - 1);
	    text -= 2;
	}
    }
    {
	if (news & 2) {
	    posh(fast, size);
	    posh(side, size);
	    move(fast, side, 1);
	    *--data = *--text;
	    *--data = *--text;
	} else {
	    *--data = *(text - 1);
	}
    }

    text = MD(file, size) + pick;

    posh(fast, size);
    move(fast, past, 1);
    *--data = *text;

    side = rule(file, size, pick);

    i = pick;
    for (; i; i--) {
	posh(fast, size);
	move(fast, side, 1);
	posh(side, size);
	*--data = *--text;
    }

    *(integral_q *) tier = news | ((Q(2) << late) - 1);

    return 0;
}


static int
seal(void *bqfset, void *club, unsigned pick, void *head, void *file,
     void *park, void *side)
{
    int (*move)(void *, void *, unsigned);
    integral_q news;
    unsigned i, j, size;
    void **iran, **pull;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    iran = ZD(side, size);

    side = rule(side, size, integral_q_bits);
    iran += integral_q_last;

    pull = MD(file, size);

    file = rule(file, size, pick);
    pull += pick;

    i = pick;
    for (; i; i--) {
	beta(side, size);
	move(side, file, 1);
	posh(file, size);
	*iran = *pull--;
	iran -= 2;
    }
    {
	beta(side, size);
	move(side, head, 1);
	*iran = *pull;
	iran -= 2;
	i--;
    }

    news = *(integral_q *) club;

    file = rule(club, size, integral_q_bits);
    pull = ZD(club, size) + integral_q_last;

    i = integral_q_line - pick - 1;
    j = integral_q_last;

    while (1 < i) {
	if (news & Q(1) << j) {
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    *iran = *pull--;
	    iran -= 2;
	    *iran = *pull--;
	    iran -= 2;
	    i -= 2;
	} else {
	    beta(side, size);
	    beta(file, size);
	    move(side, file, 1);
	    *iran = *pull;
	    iran -= 2;
	    pull -= 2;
	    i--;
	}

	j -= 2;
    }

    if (i) {
	if (news & Q(1) << j) {
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    posh(file, size);
	    move(park, file, 1);
	    *iran = *pull--;
	    iran -= 2;
	    *iran = *pull--;
	} else {
	    beta(side, size);
	    beta(file, size);
	    move(side, file, 1);
	    *iran = *pull;
	    iran -= 2;
	    pull -= 2;
	    *iran = *pull--;
	}
    } else {
	*iran = *pull--;

	j += 2;
    }

    beta(side, size);
    *((integral_q *) side) = Lx55555555;

    side = rule(club, size, integral_q_bits);
    iran = ZD(club, size) + integral_q_last;

    if (i && news & Q(1) << j) {
    } else {
	j -= 2;

	if (news & Q(1) << j) {
	    posh(file, size);
	    move(park, file, 1);
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    *iran = *pull--;
	    iran -= 2;
	} else {
	    beta(file, size);
	    move(park, file, 1);
	    pull--;
	}
    }

    while (file != side) {
	j -= 2;

	if (news & Q(1) << j) {
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    beta(side, size);
	    posh(file, size);
	    move(side, file, 1);
	    *iran = *pull--;
	    iran -= 2;
	    *iran = *pull--;
	    iran -= 2;
	} else {
	    beta(side, size);
	    beta(file, size);
	    move(side, file, 1);
	    *iran = *pull;
	    iran -= 2;
	    pull -= 2;
	}
    }

    *((integral_q *) club) = news & (Q(1) << j) - 1 | Lx55555555;

    return 0;
}


static int
sole(void *bqfset, void *tier, unsigned pick, void *past, void *file,
     void *park, void *side)
{
    int (*move)(void *, void *, unsigned);
    integral_q news;
    unsigned i, j, size;
    void **iran, **pull;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    *((integral_q *) side) = Lx55555555;

    iran = ZD(side, size) + 1;

    pull = MD(file, size);

    i = pick;
    for (; i; i--) {
	dana(side, size);
	skip(file, size);
	move(side, file, 1);
	*iran = *pull++;
	iran += 2;
    }
    {
	dana(side, size);
	move(side, past, 1);
	*iran = *pull;
	iran += 2;
    }

    news = *(integral_q *) tier;

    file = tier;
    pull = ZD(file, size);

    i = integral_q_line - pick - 1;
    j = 1;

    do {
	if (i) {
	    if (news & Q(1) << j) {
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		i--;
		*iran = *pull;
		iran += 2;
		*iran = *++pull;
		iran += 2;
	    } else {
		dana(file, size);
		pull++;
		*iran = *pull;
		iran += 2;
	    }

	    j += 2;
	} else {
	    if (news & Q(1) << j) {
		skip(file, size);
		move(park, file, 1);
		*iran = *pull;

		break;
	    } else {
		dana(file, size);
		pull++;
		*iran = *pull;

		goto mend;
	    }

	    j += 2;
	}

	while (1 < i) {
	    if (news & Q(1) << j) {
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		*iran = *++pull;
		iran += 2;
		*iran = *++pull;
		iran += 2;
		i -= 2;
	    } else {
		dana(side, size);
		move(side, file, 1);
		dana(file, size);
		pull += 2;
		*iran = *pull;
		iran += 2;
		i--;
	    }

	    j += 2;
	}

	if (i) {
	    if (news & Q(1) << j) {
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		move(park, file, 1);
		skip(file, size);
		*iran = *++pull;
	    } else {
		dana(side, size);
		move(side, file, 1);
		dana(file, size);
		pull += 2;
		*iran = *pull;
	    }
	} else {
	    j -= 2;
	}

    mend:
	side = tier;
	iran = ZD(tier, size) + 1;

	if (i && news & Q(1) << j) {
	    *iran = *++pull;
	    iran += 2;
	} else {
	    j += 2;

	    if (news & Q(1) << j) {
		move(park, file, 1);
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		*iran = *++pull;
		iran += 2;
		*iran = *++pull;
		iran += 2;
	    } else {
		move(park, file, 1);
		dana(file, size);
		pull += 2;
		*iran = *pull;
		iran += 2;
	    }
	}

	dana(side, size);

	while (file != side) {
	    j += 2;

	    if (news & Q(1) << j) {
		move(side, file, 1);
		skip(file, size);
		dana(side, size);
		move(side, file, 1);
		skip(file, size);
		*iran = *++pull;
		iran += 2;
		*iran = *++pull;
		iran += 2;
	    } else {
		move(side, file, 1);
		dana(file, size);
		pull += 2;
		*iran = *pull;
		iran += 2;
	    }

	    dana(side, size);
	}
    } while (0);

    *((integral_q *) tier) = news & ~Q(1) << j | Lx55555555;

    return 0;
}


static int
spin(void *bqfset, void *data, unsigned size, unsigned unit, void *text,
     void **park, void **plus)
{
    int status;

    do {
	integral_q news;

	news = *(integral_q *) data;

	if (~news) {
	} else {
	    status = PLAN_RERUN;
	    break;
	}

	status = bqfset(bqfset)->link_m.link
	    (bqfset(bqfset)->link_m.data, plus, integral_q_bits * unit);
	if (status) {
	    status = LINK_ERROR;
	} else {
	    unsigned i = integral_q_last, l;
	    void **iran;

	    for (; news & Q(1) << i; i -= 2);

	    *((integral_q *) data) = news | Q(1) << i;

	    l = integral_q_last - i;

	    iran = ZD(data, size);

	    data = rule(data, size, i);

	    bqfset(bqfset)->link_f.move(data, sans(data, size), l);

	    data = rule(data, size, l);

	    iran += i;
	    for (++l; l; l--) {
		*(iran - 1) = *iran;
		iran++;
	    }
	    {
		*(iran - 1) = *plus;
	    }

	    if (park) {
		*park = data;
	    } else {
		bqfset(bqfset)->link_f.move(data, text, 1);
	    }
	}
    } while (0);

    return status;
}


static int
tail(void *bqdata, void *bqtext, unsigned rate, void *turn)
{
    int status = 0;
    unsigned size;
    void *text;

    size = bqfset(bqdata)->link_a.fpnews.link_v.size;

tail:
    do {
	int (*move)(void *, void *, unsigned);
	unsigned copy, diff, late, mind;
	void *data, *file;

	late = bqfset(bqdata)->link_a.fpnews.link_v.rate;

	data = bqfset(bqdata)->link_a.fpnews.node;

	mind = *(integral_q *) data;

	diff = late - rate - 1;

	text = bqfset(bqtext)->link_a.fpnews.node;

	if (mind ^ (integral_q_bits_and_half - 1)) {
	} else {
	    status = _libx1f4l2_long_bqfset(bqdata, sans(text, size), NULL);
	    if (status) {
		break;
	    } else {
		goto tail;
	    }
	}

	file = MD(data, size)[mind];

	for (--late; late ^ rate; late--) {
	    if (~*(integral_q *) file) {
	    } else {
		if (late + 1 == bqfset(bqdata)->link_a.fpnews.link_v.rate) {
		    status = _libx1f4l2_hale_bqfset
			(bqdata, data, mind, &file, sans(text, size), NULL);
		} else {
		    status = _libx1f4l2_fare_bqfset
			(bqdata, data, integral_q_last, &file, late + 1,
			 sans(text, size), NULL);
		}
		if (status) {
		    break;
		}
	    }

	    data = file;

	    file = ZD(data, size)[integral_q_last];
	}

	copy = *(integral_q *) text;

	move = bqfset(bqdata)->link_f.move;

	if (rate) {
	    if (copy < integral_q_line) {
		unsigned deck;

		bq_q_bitcount(deck, ~*(integral_q *) file);
		if (copy < deck) {
		    status = reel(bqdata, file, copy, turn, text);
		} else {
		    void *park, *side;

		    status = (diff ? spin : rift)
			(bqdata, data, size, SIZEOF_integral_q + size, NULL,
			 &park, &side);
		    if (status) {
			break;
		    } else {
			status = seal
			    (bqdata, file, copy, turn, text, park, side);
		    }
		}
	    } else {
		void *side;

		status = (diff ? spin : rift)
		    (bqdata, data, size, SIZEOF_integral_q + size, turn, NULL,
		     &side);
		if (status) {
		    break;
		}

		if (copy < integral_q_bits) {
		    aeon(side, text, copy, 0, size, move);
		} else {
		    unsigned rend;

		    rend = copy >> 1;

		    aeon(side, text, rend, 0, size, move);

		    copy -= rend;

		    status = (diff ? spin : rift)
			(bqdata, data, size, SIZEOF_integral_q + size,
			 rule(text, size, rend + 1), NULL, &side);
		    if (status) {
			void **iran;

			iran = MD(text, size);
			rend++;
			side = rule(text, size, rend);
			memmove(iran, iran + rend, sizeof(void *) * copy);
			copy--;
			*((integral_q *) text) = copy;
			move(turn, side, 1);
			move(sans(text, size), sans(side, size), copy);

			if (status == PLAN_RERUN) {
			    goto tail;
			} else {
			    break;
			}
		    } else {
			copy--;

			aeon(side, text, copy, rend + 1, size, move);
		    }
		}
	    }
	} else {
	    if (copy < half_integral_q_bits) {
		unsigned deck;

		bq_q_bitcount(deck, ~*(integral_q *) file);
		if (deck < copy) {
		    void *park, *side;

		    status = (diff ? spin : rift)
			(bqdata, data, size, size, NULL, &park, &side);
		    if (status) {
			break;
		    } else {
			status = keel(bqdata, file, copy, text, park, side);
		    }
		} else {
		    if (copy) {
			status = peel(bqdata, file, copy, text);
		    }
		}
	    } else {
		void *side;

		skip(text, size);

		status = (diff ? spin : rift)
		    (bqdata, data, size, size, text, NULL, &side);
		if (status) {
		    break;
		}

		copy--;

		skip(text, size);

		if (copy < integral_q_bits) {
		    arch(side, text, copy, size, move);
		} else {
		    unsigned rend;

		    rend = copy >> 1;

		    arch(side, text, rend, size, move);

		    text = rule(text, size, rend);

		    copy -= rend;

		    status = (diff ? spin : rift)
			(bqdata, data, size, size, text, NULL, &side);
		    if (status) {
			side = bqfset(bqtext)->link_a.fpnews.node;
			*((integral_q *) side) = copy;
			move(sans(side, size), text, copy);

			if (status == PLAN_RERUN) {
			    goto tail;
			} else {
			    break;
			}
		    } else {
			copy--;

			skip(text, size);

			arch(side, text, copy, size, move);
		    }
		}
	    }
	}
    } while (0);

    if (status) {
    } else {
	bqfset(bqtext)->link_a.fpnews.link_v.rate = 0;

	text = bqfset(bqtext)->link_a.fpnews.node;

	*((integral_q *) text) = 0;

#if __MICRO_FSETS__
	status = bqfset(bqdata)->link_m.mode
	    (bqfset(bqdata)->link_m.data, &text, 3 * size);
	if (status) {
	    status = MODE_ERROR;
	} else {
	    bqfset(bqtext)->link_a.fpnews.node = text;
	}
#endif				/* __MICRO_FSETS__ */
    }

    return status;
}


static int
wrap(void *bqdata, void *bqtext, void *turn)
{
    int status;

    do {
	int (*move)(void *, void *, unsigned);
	unsigned i, late, rate, size, wrap;
	void *call, *data, **less, **roll, *text;

	size = bqfset(bqdata)->link_a.fpnews.link_v.size;

	data = bqfset(bqdata)->link_a.fpnews.node;
	text = bqfset(bqtext)->link_a.fpnews.node;

	move = bqfset(bqdata)->link_f.move;

	late = *(integral_q *) data;
	rate = *(integral_q *) text;

	less = MD(data, size);
	roll = MD(text, size);

	wrap = late + 1 + rate;
	if (wrap < integral_q_bits_and_half) {
	    call = rule(data, size, late + 1);

	    status = move(call, turn, 1);
	    if (status) {
		status = MOVE_ERROR;
		if (1) {
		    break;
		}
	    }

	    skip(call, size);

	    status = move(call, sans(text, size), rate);
	    if (status) {
		status = MOVE_ERROR;
		if (1) {
		    break;
		}
	    } else {
		*((integral_q *) data) = wrap;
	    }

	    less++;
	    less += late;

	    i = 1 + rate;
	    for (; i; i--) {
		*less++ = *roll++;
	    }
	} else {
	    unsigned l, rend;
	    void *grid, *grip, **iran;

	    grid = sans(data, size);
	    grip = text;

	    if (wrap < (integral_q_bits << 1)) {
		void *drag[2];

		status = _libx1f4l2_drag_bqfset(bqdata, drag);
		if (status) {
		    break;
		}

		rend = wrap >> 1;
		wrap -= rend;

		call = drag[0];

		iran = ZD(call, size);

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		l = half_integral_q_bits - rend;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		if (l) {
		} else {
		    rend--;
		}

		{
		    skip(call, size);
		    move(grip, turn, 1);
		    *iran++ = *less++;
		    rate++;
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		    *iran++ = *less++;
		    *iran++ = *less++;
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    *iran++ = *less++;
		    *iran++ = *roll++;
		    rend--;
		    rate--;
		    late = 0;
		}
		i = rend;
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		    *iran++ = *roll++;
		    *iran++ = *roll++;
		}
		if (l) {
		    skip(call, size);
		    *iran = *(iran - 1);
		    l--;
		} else {
		    iran -= 2;
		    l = 1;
		}
		i = late < l ? late : l;
		late -= i;
		l -= i;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		    iran += 2;
		    *iran = *less++;
		}
		i = l;
		rate -= i;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		    iran += 2;
		    *iran = *roll++;
		}

		MD(data, size)[0] = drag[0];

		call = drag[1];

		iran = ZD(call, size);

		if (late) {
		    move(sans(data, size), grid, 1);
		    skip(grid, size);
		    *iran++ = *less++;
		    late--;
		} else {
		    move(sans(data, size), grip, 1);
		    skip(grip, size);
		    *iran++ = *roll++;
		    rate--;
		}

		rend = wrap - 1;

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		MD(data, size)[1] = call;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		l = rend >> integral_q_rate - 1;
		rend -= l;

		{
		    skip(call, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		    *iran++ = *less++;
		    *iran++ = *less++;
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    *iran++ = *less;
		    *iran++ = *roll++;
		    rate--;
		    rend--;
		    late = 0;
		}
		if (late) {
		    skip(call, size);
		    *iran = *(iran - 1);
		}
		i = late;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		    iran += 2;
		    *iran = *less++;
		}
		i = rend;
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		    *iran++ = *roll++;
		    *iran++ = *roll++;
		}
		if (l) {
		    iran -= 2;
		}
		if (late | l) {
		} else {
		    skip(call, size);
		    *iran = *(iran - 1);
		}
		i = rate;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		    iran += 2;
		    *iran = *roll++;
		}
	    } else {
		void *drag[3];

		status = _libx1f4l2_turn_bqfset(bqdata, drag);
		if (status) {
		    break;
		}

		wrap -= 2;

		rend = wrap / 3;
		wrap -= rend;

		call = drag[0];

		iran = ZD(call, size);

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		l = half_integral_q_bits - rend;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		if (l) {
		} else {
		    rend--;
		}

		{
		    skip(call, size);
		    move(grip, turn, 1);
		    *iran++ = *less++;
		    rate++;
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		    *iran++ = *less++;
		    *iran++ = *less++;
		}
		if (false(late && rend)) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    rate--;
		    rend--;
		    late = 0;
		}
		i = false(rend);
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		}
		if (l) {
		    skip(call, size);
		    *iran = *(iran - 1);
		    l--;
		} else {
		    iran -= 2;
		    l = 1;
		}
		i = late < l ? late : l;
		late -= i;
		l -= i;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		    iran += 2;
		    *iran = *less++;
		}
		i = l;
		rate -= i;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		    iran += 2;
		    *iran = *roll++;
		}

		MD(data, size)[0] = drag[0];

		call = drag[1];

		iran = ZD(call, size);

		if (late) {
		    move(sans(data, size), grid, 1);
		    skip(grid, size);
		    *iran++ = *less++;
		    late--;
		} else {
		    move(sans(data, size), grip, 1);
		    skip(grip, size);
		    *iran++ = *roll++;
		    rate--;
		}

		rend = wrap >> 1;
		wrap -= rend;

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		l = half_integral_q_bits - rend;

		MD(data, size)[1] = call;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		if (l) {
		} else {
		    rend--;
		}

		{
		    skip(call, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		    *iran++ = *less++;
		    *iran++ = *less++;
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    *iran++ = *less++;
		    *iran++ = *roll++;
		    rate--;
		    rend--;
		    late = 0;
		}
		i = rate >> 1;
		i = i < rend ? i : rend;
		rate -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		    *iran++ = *roll++;
		    *iran++ = *roll++;
		}
		if (l) {
		    skip(call, size);
		    *iran = *(iran - 1);
		    l--;
		} else {
		    iran -= 2;
		    l = 1;
		}
		i = l < late ? l : late;
		late -= i;
		l -= i;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		    iran += 2;
		    *iran = *less++;
		}
		i = l;
		rate -= l;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		    iran += 2;
		    *iran = *roll++;
		}

		call = drag[2];

		iran = ZD(call, size);

		if (late) {
		    move(road(data, size), grid, 1);
		    skip(grid, size);
		    *iran++ = *less++;
		    late--;
		} else {
		    move(road(data, size), grip, 1);
		    skip(grip, size);
		    *iran++ = *roll++;
		    rate--;
		}

		rend = wrap;

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		MD(data, size)[2] = call;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		l = rend >> integral_q_rate - 1;
		rend -= l;

		{
		    skip(call, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		    *iran++ = *less++;
		    *iran++ = *less++;
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    *iran++ = *less++;
		    *iran++ = *roll++;
		    rate--;
		    rend--;
		    late = 0;
		}
		if (false(late)) {
		    skip(call, size);
		}
		i = false(late);
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		}
		i = rend;
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		    *iran++ = *roll++;
		    *iran++ = *roll++;
		}
		if (false(late) | l) {
		    iran -= 2;
		} else {
		    skip(call, size);
		    *iran = *(iran - 1);
		}
		i = rate;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		    iran += 2;
		    *iran = *roll++;
		}
	    }
	}

	bqfset(bqtext)->link_a.fpnews.link_v.rate = 0;

	if (1) {
	    *(integral_q *) text = 0;
	}

#if __MICRO_FSETS__
	status = bqfset(bqtext)->link_m.mode
	    (bqfset(bqtext)->link_m.data, &text, 3 * size);
	if (status) {
	    status = MODE_ERROR;
	    if (1) {
		break;
	    }
	} else {
	    bqfset(bqtext)->link_a.fpnews.node = text;
	}
#endif				/* __MICRO_FSETS__ */
    } while (0);

    return status;
}


static int
yank(void *bqdata, void *bqtext)
{
    int status;

    do {
	unsigned late, rate, size, yank;
	void *data, *text;

	size = bqfset(bqdata)->link_a.fpnews.link_v.size;

	data = bqfset(bqdata)->link_a.fpnews.node;
	text = bqfset(bqtext)->link_a.fpnews.node;

	late = *(integral_q *) data;
	rate = *(integral_q *) text;

	yank = late + rate;
	if (yank < integral_q_bits_and_half) {
#if __MICRO_FSETS__
	    unsigned fail, sans;
#endif				/* __MICRO_FSETS__ */
	    void *call;

#if __MICRO_FSETS__
	    fail = yank < 3 ? 3 : yank;
	    sans = integral_q_bits_and_half;
	    for (; fail < sans; sans >>= 1);
	    sans <<= 1;
	    if (sans == integral_q_bits_and_half) {
		sans *= (size + SIZEOF_integral_q);
	    } else {
		sans *= size;
	    }
#endif				/* __MICRO_FSETS__ */

#if __MICRO_FSETS__
	    /*
	     * resizing no matter whether is required.  and to minimum 6.
	     */
	    status = bqfset(bqdata)->link_m.mode
		(bqfset(bqdata)->link_m.data, &data, sans);
	    if (status) {
		status = MODE_ERROR;
		if (1) {
		    break;
		}
	    } else {
		bqfset(bqdata)->link_a.fpnews.node = data;
	    }
#endif				/* __MICRO_FSETS__ */

	    call = rule(data, size, late + 1);

	    status = bqfset(bqdata)->link_f.move(call, sans(text, size), rate);
	    if (status) {
		status = MOVE_ERROR;
		if (1) {
		    break;
		}
	    } else {
		*((integral_q *) data) = yank;
	    }
	} else {
	    int (*move)(void *, void *, unsigned);
	    unsigned i, l, rend;
	    void *call, *grid, *grip;

#if __MICRO_FSETS__
	    /*
	     * resizing no matter whether is required.
	     */
	    status = bqfset(bqdata)->link_m.mode
		(bqfset(bqdata)->link_m.data, &data,
		 integral_q_bits_and_half * (size + SIZEOF_integral_q));
	    if (status) {
		status = MODE_ERROR;
		if (1) {
		    break;
		}
	    } else {
		bqfset(bqdata)->link_a.fpnews.node = data;
	    }
#endif				/* __MICRO_FSETS__ */

	    move = bqfset(bqdata)->link_f.move;

	    if (yank < (integral_q_bits << 1)) {
		void *drag[2];

		status = _libx1f4l2_drag_bqfset(bqdata, drag);
		if (status) {
		    break;
		}

		rend = yank >> 1;
		yank -= rend;

		call = drag[0];

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		l = half_integral_q_bits - rend;

		MD(data, size)[0] = call;

		*(integral_q *) call = Lx55555555 | ~Q(0) >> (l << 1);

		if (l) {
		} else {
		    rend--;
		}

		{
		    skip(call, size);
		    grid = sans(data, size);
		    grip = sans(text, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    rate--;
		    rend--;
		    late = 0;
		}
		i = rend;
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		}
		if (l) {
		    skip(call, size);
		    l--;
		} else {
		    l = 1;
		}
		i = late < l ? late : l;
		late -= i;
		l -= i;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		}
		i = l;
		rate -= i;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		}

		if (late) {
		    move(sans(data, size), grid, 1);
		    skip(grid, size);
		    late--;
		} else {
		    move(sans(data, size), grip, 1);
		    skip(grip, size);
		    rate--;
		}

		rend = yank - 1;

		call = drag[1];

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		MD(data, size)[1] = call;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		l = rend >> integral_q_rate - 1;
		rend -= l;

		{
		    skip(call, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    rate--;
		    rend--;
		    late = 0;
		}
		if (late) {
		    skip(call, size);
		}
		i = late;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		}
		i = rend;
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		}
		if (late | l) {
		} else {
		    skip(call, size);
		}
		i = rate;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		}
	    } else {
		void *drag[3];

		status = _libx1f4l2_turn_bqfset(bqdata, drag);
		if (status) {
		    break;
		}

		yank -= 2;

		rend = yank / 3;
		yank -= rend;

		call = drag[0];

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		l = half_integral_q_bits - rend;

		MD(data, size)[0] = call;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		/*
		 * first node never full
		 */

		if (true(l)) {
		} else {
		    rend--;
		}

		{
		    skip(call, size);
		    grid = sans(data, size);
		    grip = sans(text, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		}
		if (false(late && rend)) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    rate--;
		    rend--;
		    late = 0;
		}
		i = false(rend);
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		}
		if (true(l)) {
		    skip(call, size);
		    l--;
		} else {
		    l = 1;
		}
		i = late < l ? late : l;
		late -= i;
		l -= i;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		}
		i = l;
		rate -= i;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		}

		if (late) {
		    move(sans(data, size), grid, 1);
		    skip(grid, size);
		    late--;
		} else {
		    move(sans(data, size), grip, 1);
		    skip(grip, size);
		    rate--;
		}

		rend = yank >> 1;
		yank -= rend;

		call = drag[1];

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		l = half_integral_q_bits - rend;

		MD(data, size)[1] = call;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		if (l) {
		} else {
		    rend--;
		}

		{
		    skip(call, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    rate--;
		    rend--;
		    late = 0;
		}
		i = rate >> 1;
		i = i < rend ? i : rend;
		rate -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		}
		if (l) {
		    skip(call, size);
		    l--;
		} else {
		    l = 1;
		}
		i = l < late ? l : late;
		late -= i;
		l -= i;
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		}
		i = l;
		rate -= l;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		}

		if (late) {
		    move(road(data, size), grid, 1);
		    skip(grid, size);
		    late--;
		} else {
		    move(road(data, size), grip, 1);
		    skip(grip, size);
		    rate--;
		}

		rend = yank;

		call = drag[2];

		*((integral_q *) call) = rend;

		rend -= integral_q_line;

		MD(data, size)[2] = call;

		*((integral_q *) call) =
		    Lx55555555 | (~Q(0) >> (half_integral_q_bits - rend << 1));

		l = rend >> integral_q_rate - 1;
		rend -= l;

		{
		    skip(call, size);
		}

		i = late >> 1;
		i = i < rend ? i : rend;
		late -= i * 2;
		rend -= i;
		for (; i; i--) {
		    move(call, grid, 2);
		    dana(call, size);
		    dana(grid, size);
		}
		if (late && rend) {
		    move(call, grid, 1);
		    skip(call, size);
		    move(call, grip, 1);
		    skip(call, size);
		    skip(grip, size);
		    rate--;
		    rend--;
		    late = 0;
		}
		if (false(late)) {
		    skip(call, size);
		}
		i = false(late);
		for (; i; i--) {
		    move(call, grid, 1);
		    dana(call, size);
		    skip(grid, size);
		}
		i = rend;
		rate -= i * 2;
		for (; i; i--) {
		    move(call, grip, 2);
		    dana(call, size);
		    dana(grip, size);
		}
		if (false(late) | l) {
		} else {
		    skip(call, size);
		}
		i = rate;
		for (; i; i--) {
		    move(call, grip, 1);
		    dana(call, size);
		    skip(grip, size);
		}
	    }
	}

	if (1) {
	    *(integral_q *) text = 0;
	}

#if __MICRO_FSETS__
	status = bqfset(bqtext)->link_m.mode
	    (bqfset(bqtext)->link_m.data, &text, 3 * size);
	if (status) {
	    status = MODE_ERROR;
	    if (1) {
		break;
	    }
	} else {
	    bqfset(bqtext)->link_a.fpnews.node = text;
	}
#endif				/* __MICRO_FSETS__ */
    } while (0);

    return status;
}


int
x1f4_join_bqfset(void *bqdata, void *bqtext)
{
    int status = 0;
    void *turn = NULL;

    do {
	unsigned late, rate;

	late = bqfset(bqdata)->link_a.fpnews.link_v.rate;
	rate = bqfset(bqtext)->link_a.fpnews.link_v.rate;

	if (late | rate) {
	    turn = malloc(bqfset(bqdata)->link_a.fpnews.link_v.size);
	    if (turn) {
	    } else {
		status = LINK_ERROR;
		break;
	    }
	}
	if (late < rate) {
	    if (late) {
		status = ever(bqdata, turn, &late);
		if (status) {
		    break;
		}
	    }
	} else {
	    if (rate) {
		status = lead(bqtext, turn, &rate);
		if (status) {
		    break;
		}
	    }
	}

	if (late == rate) {
	    if (late) {
		status = wrap(bqdata, bqtext, turn);
	    } else {
		status = yank(bqdata, bqtext);
	    }
	} else {
	    if (late < rate) {
		status = head(bqdata, bqtext, late, turn);
		if (status) {
		} else {
		    struct fpnews_type fpnews;

		    fpnews = bqfset(bqdata)->link_a.fpnews;
		    bqfset(bqdata)->link_a.fpnews =
			bqfset(bqtext)->link_a.fpnews;
		    bqfset(bqtext)->link_a.fpnews = fpnews;
		}
	    } else {
		status = tail(bqdata, bqtext, rate, turn);
	    }
	}
    } while (0);

    if (turn) {
	free(turn);
    }

    return status;
}
