/*
 * c12nd.r.c
 * Copyright (C) 2010-2013, 2016, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <af.h>
#include <c1-types.h>
#include <e4.h>

#define I_USER(i)			(*((X1f4_E4_C_USER *) (i)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_x1f4_c1_back_call(void *program, void *output, void **input)
{
    int status;
    struct c1_hold_type *upcast_data;
    void *post, **used;

    used = input[-1];

    post = input[0];

    upcast_data = used[X1f4_E4_LEAD_BACK];

    status = _x1f4_lead_effect(NULL, post);
    if (status) {
    } else {
	post = I_USER(post);

	upcast_data->node = post;
	upcast_data->slip = _x1f4_slip_effect;

	l_USER(post, output);
    }

    return status;
}
