/*
 * e2list.f.c
 * Copyright (C) 2008, 2009, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e2list-defs.h>
#include <e2list-types.h>

int
_libx1f4i0_deck_e2list(struct e2list_type *e2list_data)
{
    int status = 0;
    struct e2node_type *e2node_data;

    e2node_data = e2list_data->link_e.list;
    if (e2node_data) {
	int excess, (*free) (void *, void *);
	void *data;

	data = e2list_data->link_a.data;
	free = e2list_data->link_a.free;

	do {
	    struct e2node_type *next_e2node;

	    next_e2node = e2node_data->next_e2node;
	    excess = free(data, e2node_data);
	    if (excess) {
		status = FREE_ERROR;
	    }
	    {
		if (next_e2node) {
		} else {
		    break;
		}
		{
		    e2node_data = next_e2node->next_e2node;
		    excess = free(data, next_e2node);
		    if (excess) {
			status = FREE_ERROR;
		    }
		    {
			if (e2node_data) {
			} else {
			    break;
			}
		    }
		}
	    }
	} while (1);
    }

    return status;
}
