/*
 * e4-e.k.c
 * Copyright (C) 2006-2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4-byte.h>
#include <e4-defs.h>
#include <e4-inter.h>
#include <e4-types.h>

int
_x1f4_e4_sort_expression(struct e4_expression_type *expression_data)
{
    int type;

    type = expression_data->type;
#if __COPY_E4_POST__
    if (type == BILL) {
	expression_data->fast = C_BILL_COPY;
    } else if (type == MODE) {
	expression_data->fast = C_MODE_COPY;
    } else if (type == REAL) {
	expression_data->fast = C_REAL_COPY;
    } else if (type == TEXT) {
	expression_data->fast = C_TEXT_COPY;
    } else if (type == VOID) {
	expression_data->fast = 0;
    } else {
	expression_data->fast = C_USER_COPY;
    }
#endif				/* __COPY_E4_POST__ */
#if __LINE_E4_POST__
    if (type == BILL) {
	expression_data->post = _x1f4_e4_post_bill;
    } else if (type == MODE) {
	expression_data->post = _x1f4_e4_post_mode;
    } else if (type == REAL) {
	expression_data->post = _x1f4_e4_post_real;
    } else if (type == TEXT) {
	expression_data->post = _x1f4_e4_post_text;
    } else if (type == VOID) {
	expression_data->post = _x1f4_e4_post_void;
    } else {
	expression_data->post = _x1f4_e4_post_user;
    }
#endif				/* __LINE_E4_POST__ */

    return 0;
}
