/*
 * file.w.1.c
 * Copyright (C) 2008-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>

#include <file-defs.h>
#include <file-types.h>

#define file(file) \
    ((struct aofile_type *) (file))

int
_libx1f4i0_past_ofile(void *file, const char *data, unsigned size)
{
    int (*push)(void *, void *, unsigned), status;
    void *sd;

    push = file(file)->sf->push;

    sd = &file(file)->sd;

    while (1) {
	status = push(sd, (void *) data, size);
	if (status == -1) {
	    if (errno == EINTR) {
	    } else {
		status = PUSH_CLASS;
		if (1) {
		    break;
		}
	    }
	} else {
	    size = size - status;
	    if (size) {
		if (status) {
		    data = (char *) data + status;
		} else {
		    status = ZERO_CLASS;
		    if (1) {
			break;
		    }
		}
	    } else {
		status = 0;

		break;
	    }
	}
    }

    return status;
}
