/*
 * ix.3.c
 * Copyright (C) 2008-2012, 2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <e4fine.h>
#include <ix-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

extern const struct x1f4_operator_type _x1f4_e4_implicit[];

static int jack_case(void *, void **);

static const int c_______f[] = {
/* *INDENT-OFF* */
    X1f4_E4_CALL
/* *INDENT-ON* */
};
static const struct x1f4_operator_type _ix_3[] = {
/* *INDENT-OFF* */
    {	"(function) ",		jack_case,		0400,
	X1f4_E4_CALL,		c_______f,
	0,			11,
	NULL,			NULL				},
/* *INDENT-ON* */
};

static int
jack_case(void *output, void **input)
{
    l_USER(I_USER(input[0]), output);

    return 0;
}


int
x1f4_jack_indexset(void *context, int outer, int inner,
		   const struct x1f4_operator_type **operator)
{
    int delete = 1;
    const struct indexset_type *indexset_data;

    indexset_data = context;

    switch (outer) {
    case X1f4_E4_BILL:
	switch (inner) {
	case X1f4_E4_MODE:
	    *operator = _x1f4_e4_implicit + 0;
	    delete = 0;
	    break;
	case X1f4_E4_REAL:
	    *operator = _x1f4_e4_implicit + 1;
	    delete = 0;
	    break;
	}
	break;
    case X1f4_E4_MODE:
	switch (inner) {
	case X1f4_E4_BILL:
	    *operator = _x1f4_e4_implicit + 2;
	    delete = 0;
	    break;
	case X1f4_E4_REAL:
	    *operator = _x1f4_e4_implicit + 3;
	    delete = 0;
	    break;
	}
	break;
    case X1f4_E4_REAL:
	switch (inner) {
	case X1f4_E4_BILL:
	    *operator = _x1f4_e4_implicit + 4;
	    delete = 0;
	    break;
	case X1f4_E4_MODE:
	    *operator = _x1f4_e4_implicit + 5;
	    delete = 0;
	    break;
	}
	break;
    default:
	if (X1f4_E4_CALL < inner && X1f4_E4_CALL < outer) {
	    if (x1f4_void_e4fine
		(indexset_data->transfer_set.fine, outer, inner)) {
		*operator = _ix_3;
		delete = 0;
	    }
	}
    }

    return delete;
}
