/*
 * lxcall-a.b.c
 * Copyright (C) 2011-2014, 2016, 2017, 2019, 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <fd.h>
#include <lxcall-defs.h>
#include <lxcall-inter.h>
#include <lxcall-types.h>
#include <lxcast.h>

#if 0
static int miss_call(void *, int, void *, struct x1f4_dispatch_type **);
#endif				/* 0 */

#if 0
static int
miss_call(void *text, int success, void *output,
	  struct x1f4_dispatch_type **dispatch)
{
    *dispatch = NULL;

    return success;
}
#endif				/* 0 */


/*
 * coming in the wake of a _libx1f4i0_lxcall_long_call call, it expects
 * linetext_data->function set properly, bits include
 * X1f4_LXCALL_POST_LINE, etc.
 */
int
_libx1f4i0_lxcall_jack_call(struct x1f4_linetext_type *linetext_data,
			    int name, struct center_type *center_data,
			    struct covert_type *covert_data, int lock,
			    struct fxdata_type *fxdata_data,
			    struct x1f4_dxcast_type *dxcast_data)
{
    int status;
    void **track;

    track = center_data->input[0];

    do {
	struct x1f4_dispatch_type *dispatch_data;
	void *subtext;

	if (covert_data->swap) {
	    status = covert_data->scope_data->deck
		(&covert_data->frame_data->data);
	    if (status) {
		break;
	    }
	}

	status = _libx1f4i0_lxcall_even_tile
	    (center_data, name, lock, fxdata_data, dxcast_data);
	if (status) {
	    break;
	}

	subtext = (void *) linetext_data->context;

	((void **) track[-1])[X1f4_E4_RENDITION] = &linetext_data->function;

	dispatch_data = center_data->dispatch_data;

#if 0
	/*
	 * re-set by caller
	 */
	dispatch_data->back = NULL;
	dispatch_data->call = miss_call;
#endif				/* 0 */

	dispatch_data->transfer.context = subtext;
	dispatch_data->transfer.function_data = &linetext_data->function;
	dispatch_data->transfer.input = track;
	dispatch_data->transfer.output = center_data->output;
    } while (0);

    return status;
}
