/*
 * lxcall-e.h.c
 * Copyright (C) 2011-2014, 2016, 2017, 2019, 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <e4.h>
#include <it.h>
#include <lxcall-defs.h>
#include <lxcall-inter.h>
#include <lxcast.h>
#include <track.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define SCALAR_BITS \
    ((1 << X1f4_E4_BILL) | (1 << X1f4_E4_MODE) | (1 << X1f4_E4_REAL))

int
_libx1f4i0_lxcall_even_fare(struct center_type *center_data, unsigned bits,
			    unsigned h, unsigned o, int delete,
			    const int *data, int name, unsigned mind,
			    const int *text, int type, unsigned post,
			    int caller, unsigned *a, unsigned *b)
{
    int status = 0;

    do {
	if (type == X1f4_E4_SLIP) {
	    type = name;
	}
	if (type == X1f4_E4_CALL) {
	    if (name == X1f4_E4_CASE) {
		int fold;
		struct x1f4_dxcast_type *dxcast_data;

		dxcast_data =
		    *(void **) *(*center_data->input + o - delete);
		fold = dxcast_data->type;
		if (X1f4_E4_CALL < fold) {
		    struct x1f4_linetext_type *linetext_data;

		    linetext_data = I_USER(&dxcast_data->data);
		    if (linetext_data->function.function) {
		    } else {
			status = _libx1f4i0_lxcall_stat_null
			    (center_data->track_data);
			if (1) {
			    break;
			}
		    }
		} else {
		    status = _libx1f4i0_lxcall_stat_call
			(center_data->track_data, center_data->eelookup_data,
			 fold);
		    if (1) {
			break;
		    }
		}

		type = X1f4_E4_CASE;
	    }
	}

	if (name ^ type) {
	    do {
		if ((type | name) & ~15) {
		} else {
		    if ((1 << type | 1 << name) & ~SCALAR_BITS) {
		    } else {
			type = name;
			break;
		    }
		}

		if (name == X1f4_E4_CASE) {
		    int fold;
		    struct x1f4_dxcast_type *dxcast_data;

		    dxcast_data =
			*(void **) *(*center_data->input + o - delete);
		    fold = dxcast_data->type;
		    if (fold ^ type) {
			if ((type | fold) & ~15) {
			} else {
			    if ((1 << type) & SCALAR_BITS
				&& (1 << fold) & SCALAR_BITS) {
				type = name;
				break;
			    }
			}
		    } else {
			type = name;
			break;
		    }
		} else {
		    if (type == X1f4_E4_CASE) {
			type = name;
			(*b)++;
			break;
		    }
		}

		if (center_data->iturn_data->link) {
		    const struct x1f4_operator_type *operator_data;

		    if (center_data->iturn_data->link
			(center_data->iturn_data->text, type, name,
			 &operator_data)) {
		    } else {
			if (type == X1f4_E4_CALL) {
			    (*b)++;
			}
			type = name;
			break;
		    }
		}

		if (center_data->composer_data->link) {
		    const struct x1f4_linetext_type *linetext_data;

		    if (center_data->composer_data->link
			(center_data->composer_data->text, type, name,
			 &linetext_data)) {
		    } else {
			if (type == X1f4_E4_CALL) {
			    (*b)++;
			}
			type = name;
			break;
		    }
		}

		status = _libx1f4i0_lxcall_stat_lock
		    (center_data->track_data, center_data->eelookup_data, name,
		     type,
		     bits & POST_HOLD
		     ? -1 : text - center_data->function_text->args,
		     center_data->function_text);
	    } while (0);
	    if (name ^ type) {
		if (1) {
		    break;
		}
	    }

	    (*a)++;

	    if (post) {
		if (text[o] & X1f4_E4_POST_XSET) {
		    /*
		     * can convert the types, but not the reference.
		     * display a better descriptive message?
		     */
		    status = _libx1f4i0_lxcall_stat_fink
			(center_data->track_data,
			 text - center_data->function_text->args,
			 center_data->function_text);
		    if (1) {
			break;
		    }
		}
	    }
	} else {
	    if (bits & POST_COPY) {
		(*a)++;
		if (type == X1f4_E4_CASE) {
		    (*b)++;
		}
	    }

	    if (post) {
		if (mind) {
		    unsigned pass;

		    pass = text[o];
		    if ((data[h] ^ pass) & X1f4_E4_POST_XSET) {
			if (pass & X1f4_E4_POST_XSET) {
#if __LEFT_IMMEDIATE_REFERENCES__
			    if (type < 16 && (1 << type) & SCALAR_BITS) {
			    } else {
#endif				/* __LEFT_IMMEDIATE_REFERENCES__ */
				status = _libx1f4i0_lxcall_stat_fink
				    (center_data->track_data,
				     text - center_data->function_text->args,
				     center_data->function_text);
				if (1) {
				    break;
				}
#if __LEFT_IMMEDIATE_REFERENCES__
			    }
#endif				/* __LEFT_IMMEDIATE_REFERENCES__ */
			} else {
			    if (bits & POST_COPY) {
			    } else {
				(*a)++;
			    }
			}
		    }
		} else {
		    if (text[o] & X1f4_E4_POST_XSET) {
#if __LEFT_IMMEDIATE_REFERENCES__
			if (type < 16 && (1 << type) & SCALAR_BITS) {
			} else {
#endif				/* __LEFT_IMMEDIATE_REFERENCES__ */
			    status = _libx1f4i0_lxcall_stat_fink
				(center_data->track_data,
				 text - center_data->function_text->args,
				 center_data->function_text);
			    if (1) {
				break;
			    }
#if __LEFT_IMMEDIATE_REFERENCES__
			}
#endif				/* __LEFT_IMMEDIATE_REFERENCES__ */
		    }
		}
	    } else {
		if (mind) {
		    if (data[h] & X1f4_E4_POST_XSET) {
			if (bits & POST_COPY) {
			} else {
			    (*a)++;
			}
		    }
		}
	    }

	    if (caller == 2 && type == X1f4_E4_CASE) {
		(*b)++;
	    }
	}
    } while (0);

    return status;
}
