/*
 * lxcall-e.w.c
 * Copyright (C) 2011-2014, 2016, 2017, 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <fd.h>
#include <lxcall-defs.h>
#include <lxcall-inter.h>
#include <lxcall-types.h>
#include <lxcast.h>

static int rule_line(struct center_type *, int, unsigned, int, unsigned, int,
		     struct fxdata_type *, struct x1f4_dxcast_type *);

static int
rule_line(struct center_type *center_data, int type, unsigned o, int name,
	  unsigned flat, int lock, struct fxdata_type *missed_data,
	  struct x1f4_dxcast_type *dxcast_slip)
{
    int delete;
    void **track;

    delete = lock < o;
    if (delete) {
	if (type == X1f4_E4_SLIP) {
	    type = name;
	}

	if (name ^ type) {
	    track = *center_data->input;
	    track += lock;

	    flat = 0;

	    delete = _libx1f4i0_lxcall_rule_fare
		(center_data, name, type, track, &missed_data, &dxcast_slip);
	} else {
	    delete = 0;
	}
    }
    if (flat) {
	track = *center_data->input;
	track += lock;

	copy_miss(missed_data, name, *track);
	*track = missed_data;
	missed_data++;
    }

    return delete;
}


/*
 * POST_DATA assumed.
 */
int
_libx1f4i0_lxcall_even_ware(struct center_type *center_data,
			    int name, unsigned mind, int lock, const int *hold,
			    struct fxdata_type *fxdata_data,
			    struct x1f4_dxcast_type *dxcast_data)
{
    int delete, status = 0;
    const struct x1f4_function_type *function_text;
    unsigned o;

    function_text = center_data->function_text;

    o = function_text->count;

    do {
	int type;
	unsigned flat = 0;

	delete = lock < o;
	if (delete) {
	    const int *text;
	    unsigned post, x;

	    text = function_text->args;

	    text += lock;

	    type = *text;

	    post = function_text->flags & X1f4_E4_POST_TYPE;

	    status = _libx1f4i0_lxcall_even_fare
		(center_data, 0, 0, o, delete,
		 hold, name, mind, text, type, post, 3, &flat, &x);
	    if (status) {
		break;
	    }
	} else {
	    name = type = 0;

	    /*
	     * why is this done?  it seems copying these arguments is not
	     * required.
	     */
	    if (!mind || function_text->flags & X1f4_E4_LINK_PASS) {
	    } else {
		if (1) {
		    if (*hold & X1f4_E4_POST_XSET) {
			flat++;
		    }
		}
	    }
	}

	if (flat) {
	    status = rule_line
		(center_data, type, o, name, flat, lock, fxdata_data,
		 dxcast_data);
	}
    } while (0);

    return status;
}
