/*
 * lxcase-inter.h
 * Copyright (C) 2008-2012, 2014, 2016, 2019, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxcase_inter_H__
#define __LIBx1f4_lxcase_inter_H__

#include <e4.h>
#include <ix.h>
#include <lxlock.h>
#include <lxcase-types.h>
#include <lxwide.h>

#define _libx1f4i0_lxcase_fini_case	x1f4_fini_lxcase
#define _libx1f4i0_lxcase_fset_case	x1f4_fset_lxcase
#define _libx1f4i0_lxcase_init_case	x1f4_init_lxcase
#define _libx1f4i0_lxcase_tile_case	x1f4_tile_lxcase
#define _libx1f4i0_lxcase_vset_case	x1f4_vset_lxcase
#define _libx1f4i0_lxcase_wrap_case	x1f4_wrap_lxcase

#define __types_long(lxcase) \
    (&((struct lxcase_type *) (lxcase))->ever_a)

#define _libx1f4i0_lxcase_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_long((___l)), (___1))
#define _libx1f4i0_lxcase_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_long((___l)))
#define _libx1f4i0_lxcase_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_long((___l)))

extern int _libx1f4i0_lxcase_fini_case(void **);
extern int _libx1f4i0_lxcase_fset_case
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxcase_half_file
    (void *, void *, void **, int (*)(void *, void *, void *));
extern int _libx1f4i0_lxcase_i160312_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160312_1(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160312_2(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160312_3(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160312_4(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160313_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160314_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160725_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160725_1(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160725_2(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160727_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160727_1(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160811_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i160811_1(void *, void *, void **);
extern int _libx1f4i0_lxcase_i190419_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i190503_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i190702_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i220107_0(void *, void *, void **);
extern int _libx1f4i0_lxcase_i220107_1(void *, void *, void **);
extern int _libx1f4i0_lxcase_init_case
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxcase_stat_call(void *, const char *, const char *);
extern int _libx1f4i0_lxcase_stat_case
    (void *, const char *, const char *, long);
extern int _libx1f4i0_lxcase_stat_dori(void *, int);
extern int _libx1f4i0_lxcase_stat_fall(void *, const char *, long);
extern int _libx1f4i0_lxcase_stat_fool
    (void *, const char *, const char *, const char *);
extern int _libx1f4i0_lxcase_stat_hold(void *, const char *, long);
extern int _libx1f4i0_lxcase_stat_iran(void *, int);
extern int _libx1f4i0_lxcase_stat_kill(void *, const char *, long, long);
extern int _libx1f4i0_lxcase_stat_land
    (void *, const char *, const char *, long, long);
extern int _libx1f4i0_lxcase_stat_mill(void *, int);
extern int _libx1f4i0_lxcase_stat_park(void *, long);
extern int _libx1f4i0_lxcase_tile_case
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxcase_vset_case(void *, void **);
extern int _libx1f4i0_lxcase_wrap_case(void *, struct x1f4_indexset_type *);

#endif				/* __LIBx1f4_lxcase_inter_H__ */
