/*
 * lxcast-i.q.c
 * Copyright (C) 2010, 2011, 2013-2015, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * at the time of convertion code introduction, only looking for void
 * function assignation from non void function.
 */

#include <e4.h>
#include <lxcast-inter.h>
#include <lxcast-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxcast_q_indexed(void *context, void *output, void **input)
{
    int status;
    struct dxcast_type *object_data;
    struct fxdata_type fxdata;
    struct lxcast_type *lxcast_data;
    struct x1f4_function_type *function_data;
    void *white[2];

    function_data = ((void **) input[-1])[X1f4_E4_RENDITION];

    lxcast_data = context;

    object_data = I_USER(input[1]);

    white[0] = input[0];
    white[1] = &object_data->data;

    if (object_data->type ^ function_data->type) {
	do {
	    struct x1f4_iturn_type *iturn_data;

	    iturn_data = &lxcast_data->link_p;
	    if (iturn_data->link) {
		const struct x1f4_operator_type *operator_data;

		status = iturn_data->link
		    (iturn_data->text, function_data->type, object_data->type,
		     &operator_data);
		if (status) {
		} else {
		    status = operator_data->operator(&fxdata, white + 1);
		    if (status) {
		    } else {
			white[1] = &fxdata.data;
			break;
		    }
		}
	    }

	    status = _libx1f4i0_lxcast_stat_luck
		(lxcast_data, 1, object_data->type, function_data->type);

	    goto done;
	} while (0);
    }

    status = _libx1f4i0_lxcast_r_indexed(lxcast_data, output, white);

  done:
    return status;
}
