/*
 * lxcast-i.r.c
 * Copyright (C) 2010, 2011, 2013, 2014, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <af.h>
#include <e4.h>
#include <lxcall.h>
#include <lxcast-inter.h>
#include <lxcast-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

extern const struct x1f4_datatype_type _x1f4_af_last_type;

int
_libx1f4i0_lxcast_r_indexed(void *context, void *output, void **input)
{
    int status;
    struct lxcast_type *lxcast_data;

    lxcast_data = context;

    status = x1f4_raft_node
	(&lxcast_data->link_v, &lxcast_data->link_e,
	 (struct x1f4_datatype_type *) &_x1f4_af_last_type, I_USER(input[0]));
    if (status) {
    } else {
	status = _x1f4_lead_effect(NULL, input[1]);
	if (status) {
	} else {
	    X1f4_E4_C_USER user;

	    user = I_USER(input[1]);

	    l_USER(user, output);
	    l_USER(user, input[0]);
	}
    }

    return status;
}
