/*
 * lxcast-inter.h
 * Copyright (C) 2008-2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxcast_inter_H__
#define __LIBx1f4_lxcast_inter_H__

#include <dt.h>
#include <e4.h>
#include <ix.h>
#include <lxcast-types.h>
#include <lxlong.h>
#include <lxwide.h>

#define _libx1f4i0_lxcast_bset_cast	x1f4_bset_lxcast
#define _libx1f4i0_lxcast_cfix_cast	x1f4_cfix_lxcast
#define _libx1f4i0_lxcast_fset_cast	x1f4_fset_lxcast
#define _libx1f4i0_lxcast_fini_cast	x1f4_fini_lxcast
#define _libx1f4i0_lxcast_init_cast	x1f4_init_lxcast
#define _libx1f4i0_lxcast_lead_cast	x1f4_lead_lxcast
#define _libx1f4i0_lxcast_lock_cast	x1f4_lock_lxcast
#define _libx1f4i0_lxcast_near_cast	x1f4_near_lxcast
#define _libx1f4i0_lxcast_pset_cast	x1f4_pset_lxcast
#define _libx1f4i0_lxcast_slip_cast	x1f4_slip_lxcast
#define _libx1f4i0_lxcast_tile_cast	x1f4_tile_lxcast
#define _libx1f4i0_lxcast_tune_cast	x1f4_tune_lxcast
#define _libx1f4i0_lxcast_uset_cast	x1f4_uset_lxcast
#define _libx1f4i0_lxcast_wrap_cast	x1f4_wrap_lxcast

#define __types_long(lxcast) \
    (&((struct lxcast_type *) (lxcast))->ever_d)

#define _libx1f4i0_lxcast_stat_free(___l) \
    _libx1f4i0_lxlock_stat_free(__types_long((___l)), 0)
#define _libx1f4i0_lxcast_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_long((___l)))
#define _libx1f4i0_lxcast_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_long((___l)))
#define _libx1f4i0_lxcast_stat_xeon(___l) \
    _libx1f4i0_lxlock_stat_zero(__types_long((___l)))

extern int _libx1f4i0_lxcast_bset_cast
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxcast___class_b(void *, void *, void **);
extern int _libx1f4i0_lxcast___class_m(void *, void *, void **);
extern int _libx1f4i0_lxcast___class_r(void *, void *, void **);
extern int _libx1f4i0_lxcast___class_t(void *, void *, void **);
extern int _libx1f4i0_lxcast___class_u(void *, void *, void **);
extern int _libx1f4i0_lxcast_c_pending(void *, void *, void **);
extern int _libx1f4i0_lxcast_cfix_cast(void *, unsigned, void *);
extern int _libx1f4i0_lxcast_f_derived(void *, void *, void **);
extern int _libx1f4i0_lxcast_f_logique(void *, void *, void **);
extern int _libx1f4i0_lxcast_f_pending(void *, void *, void **);
extern int _libx1f4i0_lxcast_fini_cast(void **);
extern int _libx1f4i0_lxcast_fset_cast
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxcast_h_indexed(void *, void *, void **);
extern int _libx1f4i0_lxcast_h_logique(void *, void *, void **);
extern int _libx1f4i0_lxcast_i_logique(void *, void *, void **);
extern int _libx1f4i0_lxcast_init_cast
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxcast_lead_cast(void *, void **);
extern int _libx1f4i0_lxcast_lead_text(void *, void **);
extern int _libx1f4i0_lxcast_lock_cast
    (void *, int, int, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxcast_long_type(void *, void *, void **, int);
extern int _libx1f4i0_lxcast_near_cast(void *);
extern int _libx1f4i0_lxcast_o_logique(void *, void *, void **);
extern int _libx1f4i0_lxcast_p_derived(void *, void *, void **);
extern int _libx1f4i0_lxcast_p_indexed(void *, void *, void **);
extern int _libx1f4i0_lxcast_p_pending(void *, void *, void **);
extern int _libx1f4i0_lxcast_pset_cast
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxcast_q_indexed(void *, void *, void **);
extern int _libx1f4i0_lxcast_r_indexed(void *, void *, void **);
extern int _libx1f4i0_lxcast_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxcast_slip_cast(void *, void **);
extern int _libx1f4i0_lxcast_slip_text(void *, void **);
extern int _libx1f4i0_lxcast_stat_call(void *, int);
extern int _libx1f4i0_lxcast_stat_flat(void *, int);
extern int _libx1f4i0_lxcast_stat_lead(void *, unsigned);
extern int _libx1f4i0_lxcast_stat_lock(void *, int, int, int);
extern int _libx1f4i0_lxcast_stat_look(void *, int, int, int);
extern int _libx1f4i0_lxcast_stat_luck(void *, int, int, int);
extern int _libx1f4i0_lxcast_stat_null(void *, const char *, unsigned);
extern int _libx1f4i0_lxcast_stat_over(void *, int);
extern int _libx1f4i0_lxcast_stat_slip
    (void *, const char *, unsigned, unsigned, long);
extern int _libx1f4i0_lxcast_stat_term(void *, int, int, int, int);
extern int _libx1f4i0_lxcast_stat_time
    (void *, const char *, unsigned, unsigned, long);
extern int _libx1f4i0_lxcast_stat_zero(void *);
extern int _libx1f4i0_lxcast_t_logique(void *, void *, void **);
extern int _libx1f4i0_lxcast_tile_cast
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxcast_tune_cast(void *);
extern int _libx1f4i0_lxcast_uset_cast
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxcast_wrap_cast(void *, struct x1f4_indexset_type *);
extern int _libx1f4i0_lxcast_y_indexed(void *, void *, void **);

#endif				/* __LIBx1f4_lxcast_inter_H__ */
