/*
 * lxdash-m.a.c
 * Copyright (C) 2008-2016, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_a_class_m(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxdash_data = I_LINE(input[0]);

    effect.mode = I_MODE(input[1]);

    status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);
    if (0) {
    } else {
	if (status) {
	    if (status == X1f4_BQFSET_EVER_MATCH) {
		status = 0;
	    } else {
		status = _libx1f4i0_lxdash_stat_text
		    (lxtext_data->text, status, effect.mode);
	    }
	} else {
	    struct effect_type *effect_data;

	    effect_data = data;

	    effect_data->type = X1f4_E4_MODE;

	    effect_data->mode = effect.mode;

	    effect_data->link = ~0;

	    dxdash_data->size++;

	    l_MODE(I_MODE(input[2]), &effect_data->fxdata);
	}
    }

    return status;
}
