/*
 * lxdash-v.q-c.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <lxrail.h>

int
_libx1f4i0_lxdash_q_press_v(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    dxdash_data = I_LINE(input[0]);

    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	int name, type;
	struct effect_type *effect_data;

	effect_data = data;

	name = lxtext_data->lxtype.code;
	type = effect_data->type;

	status = _libx1f4i0_lxrail_park_node
	    (__types_rail(lxdash_data), lxtext_data, name, &type,
	     &effect_data->fxdata, output);
	if (type != name) {
	    status = _libx1f4i0_lxdash_stat_type
		(lxdash_data, effect.mode, type, name);
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
    }

    return status;
}
