/*
 * lxdata-d.l.c
 * Copyright (C) 2008-2011, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxdata-drive.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_l_derived(void *context, void *output, void **input)
{
    int delete;
    struct dxdata_type *dxdata_data, *dxdata_text;
    unsigned data, size, text;

    dxdata_data = I_DATA(input[0]);

    dxdata_text = I_DATA(input[1]);

    text = dxdata_text->length;

    data = dxdata_data->length;

    if (data ^ text) {
	size = data < text ? data : text;
    } else {
	size = data;
    }

    delete = memcmp(dxdata_data->string, dxdata_text->string, size);
    if (delete) {
	delete = delete < 0;
    } else {
	if (size ^ data) {
	    delete = 0;
	} else {
	    delete = 1;
	}
    }

    l_MODE(delete, output);

    return 0;
}
