/*
 * lxdata-f.d.f.c
 * Copyright (C) 2013-2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <string.h>

#include <e4.h>
#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-size.h>
#include <lxdata-types.h>

static void fail_data(unsigned char *, unsigned *, unsigned);

static void
fail_data(unsigned char *data, unsigned *fail, unsigned side)
{
    unsigned size;
    unsigned char *text;

    size = *fail;

    text = data;

    for (; size && *text == side; size--, text++);

    if (text != data) {
	memmove(data, text, size + 1);
    }

    *fail -= text - data;
}


int
_libx1f4i0_lxdata_dfforward(void *context, void *output, void **input)
{
    int status;
    struct dxdata_type *dxdata_data;
    unsigned size;

    dxdata_data = I_DATA(input[0]);

    size = dxdata_data->length;
    if (size) {
	unsigned rate, side;
	void *text;

	text = dxdata_data->string;

	rate = size;

	side = I_MODE(input[1]);

	if (side < 256) {
	    fail_data(text, &rate, side);
	}

	if (rate == size) {
	    status = 0;
	} else {
	    status = _libx1f4i0_lxdata_part_data(context, dxdata_data, rate);
	}
    } else {
	status = 0;
    }

    l_DATA(dxdata_data, output);

    return status;
}
