/*
 * lxdata-i.d.c
 * Copyright (C) 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-size.h>
#include <lxdata-types.h>

#define dxdata(dxdata) \
    ((struct dxdata_type *) (dxdata))

int
_libx1f4i0_lxdata_drop_line(void *lxdata, void *dxdata, void *output,
			    const char *line,
			    void (*fail)(unsigned char *, unsigned *,
					 unsigned *))
{
    int status;

    do {
	unsigned size;

	size = dxdata(dxdata)->length;
	if (size) {
	    unsigned rate, side[8];
	    void *text;

	    text = dxdata(dxdata)->string;

	    rate = size;

	    side[0] = ~0;
	    side[1] = ~0;
	    side[2] = ~0;
	    side[3] = ~0;
	    side[4] = ~0;
	    side[5] = ~0;
	    side[6] = ~0;
	    side[7] = ~0;

	    if (1) {
		unsigned c;
		unsigned char *text;

		text = (unsigned char *) line;

		c = *text;
		while (c) {
		    side[c >> 5] &= ~(1 << (c & 31));
		    c = *++text;
		}
	    }

	    fail(text, &rate, side);

	    if (rate == size) {
		status = 0;
	    } else {
		status = _libx1f4i0_lxdata_part_data(lxdata, dxdata, rate);
		if (status) {
		    break;
		}
	    }
	} else {
	    status = 0;
	}

        l_DATA(dxdata, output);
    } while (0);

    return status;
}
