/*
 * lxdata-l.y.c
 * Copyright (C) 2016, 2018, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_y_logique(void *context, void *output, void **input)
{
    int status;
    void *data;

    status = x1f4_line_lxdata(context, &data);
    if (status) {
    } else {
	struct lxdata_type *lxdata_data;

	lxdata_data = context;

	status = x1f4_raft_node
	    (&lxdata_data->link_v, &lxdata_data->link_e,
	     lxdata_data->link_t.datatype, data);
	if (status) {
	    _libx1f4i0_lxdata_slip_data(context, &data);
	} else {
	    l_DATA(data, output);
	}
    }

    return status;
}
