/*
 * lxdate-l.n.c
 * Copyright (C) 2008, 2009, 2013, 2014, 2018-2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <sys/time.h>

#include <e4.h>
#include <lxdate-drive.h>
#include <lxdate-inter.h>
#include <lxdate-types.h>

int
_libx1f4i0_lxdate_n_logique(void *context, void *output, void **input)
{
    struct dxdate_type *dxdate_data;
    struct timeval current_time;

    dxdate_data = I_DATE(input[0]);

    gettimeofday(&current_time, NULL);

    x1f4_sink_lxdate(dxdate_data, current_time.tv_sec, current_time.tv_usec);

    l_DATE(dxdate_data, output);

    return 0;
}

