/*
 * lxdate-p.f.c
 * Copyright (C) 2008-2014, 2018, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <time.h>

#include <e4.h>
#include <lxdate-drive.h>
#include <lxdate-inter.h>
#include <lxdate-types.h>

int
_libx1f4i0_lxdate_f_pending(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE window_f;
    struct dxdate_type *dxdate_data;
    time_t second_a;

    dxdate_data = I_DATE(input[0]);

    second_a = I_MODE(input[1]);
    window_f = I_MODE(input[2]);

    if (window_f < 1000000) {
	if (window_f < 0) {
	    second_a += window_f / 1000000;
	    window_f %= 1000000;
	    if (window_f) {
		second_a--;
		window_f += 1000000;
	    }
	}
    } else {
	second_a += window_f / 1000000;
	window_f %= 1000000;
    }

    _libx1f4i0_lxdate_sink_date(dxdate_data, second_a, window_f);

    l_DATE(dxdate_data, output);

    return 0;
}
