/*
 * lxdecq-v.x.f.c
 * Copyright (C) 2008-2010, 2013-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <f_list.h>
#include <lxcall.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

#define lxtext(delete)			((struct lxtext_type *) (delete))

int
_libx1f4i0_lxdecq_xfclass_v(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxdecq_type *lxdecq_data;
    struct lxtext_type *lxtext_data;
    void *data, *list;

    lxtext_data = context;

    lxdecq_data = lxtext_data->text;

    dxlist_data = I_LIST(input[0]);

    list = dxlist_data->list;

    status = _libx1f4i0_lead_dllist(dxlist_data->list, &data);
    if (status) {
	status = _libx1f4i0_lxdecq_stat_list(lxdecq_data, 0, status);
    } else {
	struct lxtext_type *lxtext_data;
	unsigned type;

	lxtext_data = context;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxdecq_stat_type
		(lxdecq_data, 0, type, lxtext_data->lxtype.code);
	} else {
	    void *fast;

	    fast = E_USER(data);

	    l_USER(fast, output);

	    status = lxtext_data->lxtype.push
		(lxtext_data->lxtype.context, output, fast,
		 lock_excase(dxlist_data));
	    if (status) {
	    } else {
		link_effect(data, ~0);

		status = _libx1f4i0_mind_dllist(list);
		if (status) {
		    status = _libx1f4i0_lxdecq_stat_list
			(lxdecq_data, 0, status);
		} else {
		    dxlist_data->size--;
		}
	    }
	}
    }

    return status;
}
