/*
 * lxfile-c.d.c
 * Copyright (C) 2008-2010, 2013, 2014, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <unistd.h>

#include <e4.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

#define I_FILE(t)			(*((X1f4_E4_C_USER *) (t)))

#define exfile(file) \
    ((struct exfile_type *) (file)->socket)

int
_libx1f4i0_lxfile_d_centric(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxfile_type *dxfile_data;
	void *file;

	dxfile_data = I_FILE(input[0]);

	file = dxfile_data->file;
	if (file) {
	    int fd;

	    status = exfile(dxfile_data)->ever(file, &fd);
	    if (status) {
		status = 0;
	    } else {
#if defined _POSIX_SYNCHRONIZED_IO
		status = fdatasync(fd);
#else
		status = fsync(fd);
#endif				/* _POSIX_SYNCHRONIZED_IO */
		if (status) {
		    status = _libx1f4i0_lxfile_stat_will(context);
		    if (1) {
			break;
		    }
		}
	    }
	} else {
	    status = 0;
	}

	l_FILE(dxfile_data, output);
    } while (0);

    return status;
}
