/*
 * lxfile-f.o.c
 * Copyright (C) 2008-2011, 2013, 2016, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <unistd.h>

#include <e4.h>
#include <lxfile-defs.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

int
_libx1f4i0_lxfile_o_forward(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxfile_type *dxfile_data;
	struct lxfile_type *lxfile_data;
	unsigned bits;

	dxfile_data = I_FILE(input[0]);

	lxfile_data = context;

	if (dxfile_data->file) {
	    status = x1f4_lose_dxfile(lxfile_data, dxfile_data);
	    if (status) {
		break;
	    }
	}

	bits = lxfile_data->link_i.bits;

	lxfile_data->link_i.bits = bits & ~SETCLOSE_LINK;

	status = x1f4_posh_dxfile
	    (lxfile_data, dxfile_data, STDOUT_FILENO, POSH_SPACE);
	if (status) {
	} else {
	    l_FILE(dxfile_data, output);
	}

	lxfile_data->link_i.bits = bits;
    } while (0);

    return status;
}
