/*
 * lxfile-p.p.c
 * Copyright (C) 2008, 2009, 2010, 2013, 2016, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <file.h>
#include <lxfile-defs.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

int
_libx1f4i0_lxfile_p_pending(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE road;
	struct dxfile_type *dxfile_data;
	void *file;

	dxfile_data = I_FILE(input[0]);

	road = I_MODE(input[1]);

	file = dxfile_data->file;
	if (1) {
	    int peep;

	    if (dxfile_data->mode != READ_CLASS) {
		status = _libx1f4i0_lxfile_stat_turn(context, dxfile_data);
		if (1) {
		    break;
		}
	    }

	    if (road & ~((1 << 28) - 1)) {
		status = _libx1f4i0_lxfile_stat_peep(context, road);
		if (1) {
		    break;
		}
	    }

	    status = _libx1f4i0_peep_ifile(file, road, &peep);
	    if (status) {
		if (status == FILE_OVER_CLASS) {
		    status = 0;

		    l_MODE(-1, output);
		} else {
		    if (status == FILE_PEEP_CLASS) {
			status = _libx1f4i0_lxfile_stat_peep
			    (context, road);
		    } else {
			status = _libx1f4i0_lxfile_stat_file
			    (context, status);
		    }
		}
	    } else {
		l_MODE(peep, output);
	    }
	}
    } while (0);

    return status;
}
