/*
 * lxfile-p.s.c
 * Copyright (C) 2008-2010, 2013, 2014, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

#define I_FILE(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_FILE(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define lock_exfile(file) \
    (file)

int
_libx1f4i0_lxfile_s_pending(void *context, void *output, void **input)
{
    int status;
    struct dxfile_type *dxfile_flat, *dxfile_text;
    struct lxfile_type *lxfile_data;

    dxfile_flat = I_FILE(input[0]);
    dxfile_text = I_FILE(input[1]);

    lxfile_data = context;

    do {
	if (dxfile_flat) {
	    status = x1f4_raft_node
		(&lxfile_data->link_v, &lxfile_data->link_e,
		 lxfile_data->link_t.datatype, dxfile_flat);
	    if (status) {
		break;
	    }
	} else {
	    status = 0;
	}

	lock_exfile(dxfile_text)->call++;

	l_FILE(dxfile_text, input[0]);
	l_FILE(dxfile_text, output);
    } while (0);

    return status;
}
