/*
 * lxline-a.n.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more delands.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxline-drive.h>
#include <lxline-parts.h>
#include <lxline-types.h>

#define pxedit(pxedit)			((struct pxedit_type *) (pxedit))

int
_libx1f4i0_lxline_miss_link(void *text, void *data)
{
    int status = 0;

    do {
	unsigned link;

	link = effect_link(data);
	if (~link) {
	    int (*free)(void *, void *, struct excase_type **,
			const struct excase_type *);
	    struct lxtext_type *lxtext_link;

	    lxtext_link = pxedit(text)->lxtext_data + link;

	    free = lxtext_link->lxtype.free;
	    if (free) {
		status = free
		    (lxtext_link->lxtype.context, E_USER(data), NULL,
		     pxedit(text)->excase_data);
		if (status) {
		    pxedit(text)->success = status;
		    if (1) {
			break;
		    }
		} else {
		    link_effect(data, ~0);
		}
	    }
	}

	pxedit(text)->miss++;
    } while (0);

    return status;
}
