/*
 * lxline-d.g.c
 * Copyright (C) 2008-2017, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_g_derived(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    lxline_data = context;

    dxline_data = I_LINE(input[1]);

    fail = I_TEXT(input[2]);

    status = _libx1f4i0_find_sfnote(dxline_data->line, fail, &data);
    if (status) {
	unsigned call, type;

	type = effect_type(data);
	call = *((struct x1f4_function_type *)
		 ((void **) input[-1])[X1f4_E4_RENDITION])->args;
	if (type != call) {
	    status = _libx1f4i0_lxline_stat_type
		(lxline_data, fail, type, call);
	} else {
	    unsigned link;

	    link = effect_link(data);

	    status = 0;

	    do {
		if (~link) {
		    struct lxtext_type *lxtext_data;

		    lxtext_data = lxline_data->link_f.text;
		    lxtext_data += link;
		    if (lxtext_data->lxtype.lead && lxtext_data->lxtype.slip) {
			status = _libx1f4i0_lxcall_rule_node
			    (&lxline_data->link_v, &lxline_data->link_e,
			     &lxtext_data->lxtype, E_USER(data),
			     input[0]);
			if (1) {
			    break;
			}
		    }

		    if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
			status = _libx1f4i0_lxcall_side_node
			    (&lxtext_data->lxtype, E_USER(data),
			     input[0]);
			if (1) {
			    break;
			}
		    }
		}

		copy_miss(*input, type, effect_data(data));
	    } while (0);
	    if (status) {
	    } else {
		status = _libx1f4i0_lxrail_cast_data
		    (lxline_data, output, type, *input);
	    }
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss(lxline_data, fail);
    }

    return status;
}
