/*
 * lxline-l.c.c
 * Copyright (C) 2008-2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_c_logique(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data, *dxline_text;

    dxline_data = I_LINE(input[0]);
    dxline_text = I_LINE(input[1]);

    if (dxline_data == dxline_text) {
	status = 0;
    } else {
	void *dxtext;

	status = _libx1f4i0_lxline_line_line(context, &dxtext);
	if (status) {
	} else {
	    status = _libx1f4i0_lxline_late_line
		(context, dxline_data, dxtext, dxline_text);
	    if (status) {
	    } else {
		status = _libx1f4i0_lxline_null_line
		    (context, NULL, dxline_data);
		if (status) {
		} else {
		    status = _libx1f4i0_lxline_swap_line(dxtext, dxline_data);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxline_flat_line(context, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    if (status) {
    } else {
	l_LINE(dxline_data, output);
    }

    return status;
}
