/*
 * lxline-l.s.c
 * Copyright (C) 2008-2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_s_logique(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    fail = I_TEXT(input[1]);

    status = _libx1f4i0_find_sfnote(dxline_data->line, fail, &data);
    if (status) {
	X1f4_E4_C_TEXT land;
	void *text;

	land = I_TEXT(input[2]);

	status = _libx1f4i0_find_sfnote(dxline_data->line, land, &text);
	if (status) {
	    int trip;
	    struct fxdata_type fxdata;

	    trip = effect_type(data);
	    type_effect(data, effect_type(text));
	    type_effect(text, trip);
	    trip = effect_link(data);
	    link_effect(data, effect_link(text));
	    link_effect(text, trip);

	    fxdata = *(struct fxdata_type *) effect_data(data);
	    *(struct fxdata_type *) effect_data(data) =
		*(struct fxdata_type *) effect_data(text);
	    *(struct fxdata_type *) effect_data(text) = fxdata;

	    status = 0;
	} else {
	    status = _libx1f4i0_lxline_stat_miss(lxline_data, land);
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss(lxline_data, fail);
    }

    return status;
}
