/*
 * lxline-p.d.c
 * Copyright (C) 2008-2013, 2017, 2018, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-parts.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_d_pending(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct pxedit_type pxedit;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    fail = I_TEXT(input[1]);

    pxedit.excase_data = lock_excase(dxline_data);
    pxedit.lxtext_data = lxline_data->link_f.text;
    pxedit.miss = 0;
    pxedit.success = 0;

    status = _libx1f4i0_drop_sfnote
	(dxline_data->line, fail, &pxedit, _libx1f4i0_lxline_miss_link);
    if (status) {
	if (status == X1f4_SFNOTE_MISS_CLASS) {
	    status = _libx1f4i0_lxline_stat_miss(lxline_data, fail);
	} else {
	    status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
	}
    } else {
	status = pxedit.success;
	if (status) {
	} else {
	    l_LINE(dxline_data, output);

	    dxline_data->size -= pxedit.miss;
	}
    }

    return status;
}
