/*
 * lxline-p.e.c
 * Copyright (C) 2008-2018, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-parts.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_e_pending(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct x1f4_sfnote_type sfnote;
    void *line, *part;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    sfnote.trans = &lxline_data->link_m;

    line = dxline_data->line;

    status = _libx1f4i0_init_sfnote(&part, X1f4_SFNOTE_TRANS_MASK, &sfnote);
    if (status) {
    } else {
	int excess;
	void *half;

	status = _libx1f4i0_init_sfnote
	    (&half, X1f4_SFNOTE_TRANS_MASK, &sfnote);
	if (status) {
	} else {
	    status = _libx1f4i0_tear_sfnote(line, I_TEXT(input[2]), 1, part);
	    if (status) {
	    } else {
		status = _libx1f4i0_tear_sfnote
		    (line, I_TEXT(input[1]), 0, half);
		if (status) {
		} else {
		    status = _libx1f4i0_join_sfnote(line, part);
		    if (status) {
		    } else {
			struct pxedit_type pxedit;

			pxedit.excase_data = lock_excase(dxline_data);
			pxedit.lxtext_data = lxline_data->link_f.text;
			pxedit.miss = 0;
			pxedit.success = 0;

			_libx1f4i0_lime_sfnote
			    (half, &pxedit, _libx1f4i0_lxline_miss_link);

			dxline_data->size -= pxedit.miss;
		    }
		}
	    }

	    excess = _libx1f4i0_fini_sfnote(&half);
	    if (excess) {
		if (status) {
		} else {
		    status = excess;
		}
	    }
	}

	excess = _libx1f4i0_fini_sfnote(&part);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	l_LINE(dxline_data, output);
    }

    return status;
}
