/*
 * lxline-r.g.0.c
 * Copyright (C) 2008-2015, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_g0class_r(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    void *data;

    cxbend_data = context;

    dxline_data = I_LINE(input[1]);

    status = cxbend_data->pick(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(cxbend_data->line, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != X1f4_E4_REAL) {
	    status = _libx1f4i0_lxline_stat_ends
		(cxbend_data->line, cxbend_data->bend, type, X1f4_E4_REAL);
	} else {
	    X1f4_E4_C_REAL real;

	    real = E_REAL(data);
	    l_REAL(real, input[0]);
	    l_REAL(real, output);
	}
    }

    return status;
}
