/*
 * lxline-r.q-c.c
 * Copyright (C) 2008-2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define lxtext(lxtext)			((struct lxtext_type *) (lxtext))

int
_libx1f4i0_lxline_y_class_r(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    void *data;

    dxline_data = I_LINE(input[0]);

    status = _libx1f4i0_find_sfnote
	(dxline_data->line, I_TEXT(input[1]), &data);
    if (status) {
	unsigned type;

	status = 0;

	type = effect_type(data);
	switch (type) {
	case X1f4_E4_BILL:
	    l_REAL(E_BILL(data), output);
	    break;
	case X1f4_E4_MODE:
	    l_REAL(E_MODE(data), output);
	    break;
	case X1f4_E4_REAL:
	    l_REAL(E_REAL(data), output);
	    break;
	default:
	    status = _libx1f4i0_lxline_stat_type
		(lxtext(context)->text, I_TEXT(input[1]), type, X1f4_E4_REAL);
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss
	    (lxtext(context)->text, I_TEXT(input[1]));
    }

    return status;
}
