/*
 * lxline-t.x.0.c
 * Copyright (C) 2008-2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_x0class_t(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    cxbend_data = context;

    lxline_data = cxbend_data->line;

    dxline_data = I_LINE(input[0]);

    status = cxbend_data->pick(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != X1f4_E4_TEXT) {
	    status = _libx1f4i0_lxline_stat_ends
		(lxline_data, cxbend_data->bend, type, X1f4_E4_TEXT);
	} else {
	    status = _libx1f4i0_lxcall_pick_text
		(&lxline_data->ever_a, effect_data(data));
	    if (status) {
	    } else {
		l_TEXT(E_TEXT(data), output);

		link_effect(data, ~0);

		status = cxbend_data->slip(dxline_data->line);
		if (status) {
		    status =
			_libx1f4i0_lxline_stat_line(lxline_data, 0, status);
		} else {
		    dxline_data->size--;
		}
	    }
	}
    }

    return status;
}
