/*
 * lxline-u.e.f.c
 * Copyright (C) 2008-2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-config.h>

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_efclass_u(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxline_data = lxtext_data->text;

    dxline_data = I_LINE(input[1]);

    status = _libx1f4i0_lead_sfnote(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxline_stat_ends
		(lxline_data, 0, type, lxtext_data->lxtype.code);
	} else {
	    X1f4_E4_C_USER fast;

	    fast = E_USER(data);

	    status = _libx1f4i0_mind_sfnote(dxline_data->line);
	    if (status) {
		status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
	    } else {
		dxline_data->size--;

		if (0) {
		} else {
		    l_USER(fast, input[0]);
		    l_USER(fast, output);
		}
	    }
	}
    }

    return status;
}
