/*
 * lxline-v.q.f.c
 * Copyright (C) 2008-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define lxtext(delete)			((struct lxtext_type *) (delete))

int
_libx1f4i0_lxline_qfclass_v(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxline_data = lxtext_data->text;

    dxline_data = I_LINE(input[0]);

    status = _libx1f4i0_lead_sfnote(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	struct lxtext_type *lxtext_data;
	unsigned type;

	lxtext_data = context;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxline_stat_ends
		(lxline_data, 0, type, lxtext_data->lxtype.code);
	} else {
	    status = x1f4_auto_node
		(&lxline_data->link_v, &lxline_data->link_e,
		 &lxtext_data->lxtype, effect_data(data), output);
	}
    }

    return status;
}
