/*
 * lxlist-r.g.0.c
 * Copyright (C) 2008-2011, 2013-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define l_REAL(e, output) \
    {									      \
	X1f4_E4_C_REAL *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxlist_g0class_r(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    unsigned size;

    cxbend_data = context;

    dxlist_data = I_LIST(input[1]);

    size = dxlist_data->size;
    if (!size) {
	status = _libx1f4i0_lxlist_stat_null(cxbend_data->list);
    } else {
	void *data;

	status = cxbend_data->pick(dxlist_data->list, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(cxbend_data->list, 0, status);
	} else {
	    unsigned type;

	    type = effect_type(data);
	    if (type != X1f4_E4_REAL) {
		status = _libx1f4i0_lxlist_stat_ends
		    (cxbend_data->list, cxbend_data->bend, type, X1f4_E4_REAL);
	    } else {
		X1f4_E4_C_REAL real;

		real = E_REAL(data);
		l_REAL(real, input[0]);
		l_REAL(real, output);
	    }
	}
    }

    return status;
}
