/*
 * lxlong-a.e.c
 * Copyright (C) 2008-2010, 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <er.h>
#include <exerrors.h>
#include <lxlong-types.h>

#define lxlong(lxlong) \
    ((struct lxlong_type *) (lxlong))

int
_libx1f4i0_lxlong_stat_lead(void *lxlong, unsigned type)
{
    LINE_EEER(lxlong(lxlong)->link_e);

    PUSH_DATA("will not box non referable, non intrinsic object of type ", 57);
    PUSH_TRAP(type, lxlong(lxlong));

    POST_EEER();

    return X1f4_EX_CAN_CONTINUE;
}


int
_libx1f4i0_lxlong_stat_pick(void *lxlong, unsigned type)
{
    LINE_EEER(lxlong(lxlong)->link_e);

    PUSH_DATA("bad index type (", 16);
    PUSH_TRAP(type, lxlong(lxlong));
    PUSH_DATA(")", 1);

    POST_EEER();

    return X1f4_EX_CAN_CONTINUE;
}
