/*
 * lxnear-i.t.c
 * Copyright (C) 2021, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <cardinal.p-d.h>
#include <lcardinal.v-d.h>
#include <lxdate.h>

#define PRE				15

int
_libx1f4i0_lxnear_push_time(void *data,
			    int (*push)(void *, const char *, unsigned),
			    void *dxtime)
{
    int status;
    struct x1f4_dxtime_type *dxtime_data;

    dxtime_data = dxtime;

    if (dxtime_data->second_l & 1 << 17) {
	status = push(data, "-", 1);
    } else {
	status = 0;
    }
    if (status) {
    } else {
	status = x1f4_vprint_dlcardinal(data, push, dxtime_data->second_a);
	if (status) {
	} else {
	    unsigned second_f;

	    second_f = dxtime_data->second_f;
	    if (second_f) {
		/* may have uninitialized data */
		char m[1 + PRE + 6], *n;
		int k;

		n = m + 1 + PRE + 6;
		x1f4_xprint_dcardinal(&n, second_f);
		k = n - m - 1 - PRE;
		if (0 < k) {
		    memset(m + 1 + PRE, '0', k);
		}
		m[PRE] = '.';
		for (n = m + 1 + PRE + 5; *n == '0'; n--);
		status = push(data, m + PRE, n + 1 - m - PRE);
	    }
	}
    }

    return status;
}
