/*
 * lxnear-p.m.c
 * Copyright (C) 2008-2011, 2013, 2016-2018, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxnear-defs.h>
#include <lxnear-drive.h>
#include <lxnear-inter.h>
#include <lxnear-types.h>

int
_libx1f4i0_lxnear_m_pending(void *context, void *output, void **input)
{
    X1f4_E4_C_BILL bill;
    X1f4_E4_C_MODE mode;
    char line[(sizeof(X1f4_E4_C_BILL) * 8 + 6) / 7], *m;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    if (lxtext_data->bits & TYPED_TEXT) {
	X1f4_E4_C_USER user;

	user = I_USER(input[0]);
	lxtext_data->lead[1] = user;
	l_USER(user, output);
	input++;
    }

    mode = I_MODE(input[0]);
    bill = (X1f4_E4_C_BILL) mode << 1;
    bill ^= mode >> (sizeof(X1f4_E4_C_BILL) * 8 - 1);

    m = line + sizeof(line) - 1;

    *m = bill & 127;
    bill >>= 7;
    while (bill) {
	--m;
	*m = (bill & 127) | 128;
	bill >>= 7;
    }

    return lxtext_data->push(lxtext_data->data, m, line + sizeof(line) - m);
}

