/*
 * lxnova.h
 * Copyright (C) 2015, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxnova_H__
#define __LIBx1f4_lxnova_H__

#include <dt.h>
#include <ln.h>
#include <lxlong.h>

#define nova_NULL			((void *) 0)

#define nova_offsetof(type, ceil) \
    ((integral_q) (&((type *) nova_NULL)->ceil))

#define lock_lnnova(___p) \
    ((struct x1f4_leadnode_type *)					      \
     ((char *) (___p) - sizeof(struct x1f4_leadnode_type)))

#define lock_lnlink(___p) \
    (&lock_lnnova((___p))->link)

#define lock_lnline(___p) \
    (&lock_lnnova((___p))->line)

#define near_lnnova(___k) \
    ((struct x1f4_leadnode_type *)					      \
     ((char *) (___k) - nova_offsetof(struct x1f4_leadnode_type, link)))

#define near_lnline(___k) \
    (&near_cxnova((___k))->line)

#undef ever_a

#define ever_a				ever_n.nice_1.east_1

#undef link_e
#undef link_m
#undef link_v
#undef link_w

#define link_e				ever_n.nice_1.east_1.diff_e
#define link_m				ever_n.nice_1.east_1.diff_m
#define link_v				ever_n.nice_1.east_1.diff_v
#define link_w				ever_n.nice_1.east_1.diff_w

#undef trap_e

#define trap_e				ever_n.nice_1.east_e

#define link_t				ever_n.nice_t

typedef struct lxnova_type {
    struct lxlong_type nice_1;
    struct {
	struct x1f4_datatype_type datatype[3];
    } nice_t;
} lxnova_type;

extern int _libx1f4i0_lxnova_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxnova_s_pending(void *, void *, void **);

#endif				/* __LIBx1f4_lxnova_H__ */
