/*
 * lxplus.h
 * Copyright (C) 2015, 2016, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxplus_H__
#define __LIBx1f4_lxplus_H__

#include <lxnorm.h>
#include <nt.h>

#undef ever_a

#define ever_a				ever_p.rule_1.nice_1.east_1

#undef link_e
#undef link_m
#undef link_v
#undef link_w

#define link_e				ever_p.rule_1.nice_1.east_1.diff_e
#define link_m				ever_p.rule_1.nice_1.east_1.diff_m
#define link_v				ever_p.rule_1.nice_1.east_1.diff_v
#define link_w				ever_p.rule_1.nice_1.east_1.diff_w

#undef link_f
#undef trap_e

#define link_f				ever_p.rule_1.nice_1.east_f
#define trap_e				ever_p.rule_1.nice_1.east_e

#undef link_t

#define link_t				ever_p.rule_1.nice_t

#define link_r				ever_p.rule_r
#define link_s				ever_p.rule_s

#define _libx1f4i0_lxplus_move_plus	x1f4_move_lxplus
#define _libx1f4i0_lxplus_pick_plus	x1f4_pick_lxplus

typedef struct lxplus_type {
    struct lxnorm_type rule_1;
    struct {
	int (*call)(void *, struct x1f4_nodelink_type *),
	    (*fine)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *),
	    (*miss)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *);
	void *text;
    } rule_r;
    struct {
	struct x1f4_nodetype_type nodetype[1];
    } rule_s;
} lxplus_type;

extern int _libx1f4i0_lxplus_move_plus
    (void *, void *, const struct x1f4_nodelink_type *,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxplus_pick_plus
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);

#endif				/* __LIBx1f4_lxplus_H__ */
