/*
 * lxrail-o.s.c
 * Copyright (C) 2014-2017, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxrail-types.h>
#include <mxdeck.h>

int
_libx1f4i0_lxrail_link_last(struct x1f4_linetrap_type *linetrap_data,
			    struct depart_type *depart_data,
			    const struct patent_type *patent_data)
{
    depart_data->ftsl_blaw->linetext_data = NULL;
    depart_data->ftsl_blaw->type = X1f4_E4_VOID;
    depart_data->ftsl_llaw->linetext_data = NULL;
    depart_data->ftsl_llaw->type = X1f4_E4_VOID;
    depart_data->ftsl_plaw->linetext_data = NULL;
    depart_data->ftsl_plaw->type = X1f4_E4_VOID;
    depart_data->ftsl_rlaw->linetext_data = NULL;
    depart_data->ftsl_rlaw->type = X1f4_E4_VOID;

    x1f4_post_mxpath
	(linetrap_data->fpaccess, patent_data->name, patent_data->size,
	 depart_data->fpdetail_blaw);
    patent_data++;
    x1f4_post_mxpath
	(linetrap_data->fpaccess, patent_data->name, patent_data->size,
	 depart_data->fpdetail_llaw);
    patent_data++;
    x1f4_post_mxpath
	(linetrap_data->fpaccess, patent_data->name, patent_data->size,
	 depart_data->fpdetail_plaw);
    patent_data++;
    x1f4_post_mxpath
	(linetrap_data->fpaccess, patent_data->name, patent_data->size,
	 depart_data->fpdetail_rlaw);

    return 0;
}
