/*
 * lxrail-p.v.c
 * Copyright (C) 2011-2019, 2021, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcast.h>
#include <lxrail-drive.h>
#include <lxrail-inter.h>
#include <lxrail-types.h>

extern const void *const x1f4_a1_walk_link;

int
_libx1f4i0_lxrail_v_pending(void *context, void *output, void **input,
			    void **track, void *dxrail, int over,
			    unsigned count, const char *name,
			    int (*ever)(struct lxrail_type *,
					struct fydata_type *, void *))
{
    int status;

    do {
	X1f4_E4_C_MODE jack;
	struct x1f4_dxcast_type *dxcast_data;
	const struct x1f4_function_type *function_text;
	struct x1f4_linetext_type *linetext_data;
	unsigned class, grade;
	void **used;

	used = track[-1];

	dxcast_data = I_USER(track[1]);

	if (X1f4_E4_CALL < dxcast_data->type) {
	} else {
	    status = _libx1f4i0_lxrail_stat_roll(context, name, 7);
	    break;
	}

	linetext_data = I_USER(&dxcast_data->data);

	if (linetext_data->function.function) {
	} else {
	    status = _libx1f4i0_lxrail_stat_zero(context);
	    break;
	}

	function_text = used[X1f4_E4_RENDITION];

	class = function_text->count - 3;

	grade = class + 1;

	jack = I_MODE(track[2]);

	if (jack < -(int) grade || !(jack < (int) grade)) {
	    status = _libx1f4i0_lxrail_stat_land(context, grade, jack);

	    break;
	}

	if (jack < (X1f4_E4_C_MODE) 0) {
	    jack += grade;
	}

	if (count) {
	    status = _libx1f4i0_lxrail_into_rail
		(context, output, input, track, linetext_data, count,
		 function_text, 3, jack, dxrail, over, ever);
	} else {
	    status = 0;

	    if (output == x1f4_a1_walk_link) {
		input[2] = NULL;
	    }
	}
    } while (0);

    return status;
}
