/*
 * lxtext-c.a.c
 * Copyright (C) 2008-2010, 2013, 2014, 2017, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <string.h>

#include <e4.h>
#include <lintegral.p-fd.h>
#include <lxtext-inter.h>
#include <lxtext-types.h>

#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxtext_i200731_0(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE f;
    int status;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;


    f = I_MODE(input[1]);
    if (f < 0) {
	status = _libx1f4i0_lxtext_stat_band(lxtext_data, f);
    } else {
	void *text;

	status = lxtext_data->link_v.link
	    (lxtext_data->link_v.data, &text, 21 < f ? f : 21);
	if (status) {
	    status = _libx1f4i0_lxtext_stat_link(lxtext_data);
	} else {
	    char *miss;

	    miss = (char *) text + 20;
	    *miss = 0;
	    x1f4_xprint_fdlintegral(&miss, f, I_MODE(input[0]));

	    l_TEXT(miss, output);
	}
    }

    return status;
}
