/*
 * lxtrap-i.m.c
 * Copyright (C) 2019, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxtrap-drive.h>
#include <lxtrap-inter.h>

int
_libx1f4i0_lxtrap_mill_lock(void *context, void *order, unsigned mill)
{
    X1f4_E4_C_MODE mode;
    int status = 0;

    mode = I_MODE(order);
    if (mode < 0) {
	if (mode < -(int) mill) {
	    status = _libx1f4i0_lxtrap_stat_slip(context, mill, mode);
	} else {
	    l_MODE(mode + mill, order);
	}
    } else {
	if (mill <= mode) {
	    status = _libx1f4i0_lxtrap_stat_slip(context, mill, mode);
	}
    }

    return status;
}
