/*
 * lxvery-a.j.c
 * Copyright (C) 2017-2019, 2021, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxvery-types.h>
#include <progress.h>

static const struct x1f4_position_type position_0x[] = {
/* *INDENT-OFF* */
    {
    {	"m_key(;*, ;0)",	1,	0,	0,	1,	13	},
	X1f4_PROGRESS_EQCLAUSE
    },
    {
    {	"msk_upper(;*, ;0, ;0)",
				2,	0,	0,	1,	21	},
	X1f4_PROGRESS_GECLAUSE
    },
    {
    {	"msk_greater(;*, ;0, ;0)",
				2,	0,	0,	1,	23	},
	X1f4_PROGRESS_GTCLAUSE
    },
    {
    {	"msk_lower(;*, ;0, ;0)",
				2,	0,	0,	1,	21	},
	X1f4_PROGRESS_LECLAUSE
    },
    {
    {	"msk_less(;*, ;0, ;0)",	2,	0,	0,	1,	20	},
	X1f4_PROGRESS_LTCLAUSE
    },
/* *INDENT-ON* */
};
static const struct x1f4_progress_type progress_0b = {
/* *INDENT-OFF* */
    {	"msk_less(;*, ;0, ;0)",	2,	0,	0,	1,	20	},
    {	"m_last(;*, ;0)",	1,	0,	0,	1,	14	},
	X1f4_E4_MODE,	0,		0,
	X1f4_PROGRESS_BACKWARD | X1f4_PROGRESS_POSITION,	1,
	position_0x
/* *INDENT-ON* */
}, progress_0f = {
/* *INDENT-OFF* */
    {	"msk_greater(;*, ;0, ;0)",
				2,	0,	0,	1,	23	},
    {	"m_first(;*, ;0)",	1,	0,	0,	1,	15	},
	X1f4_E4_MODE,	0,		0,
	X1f4_PROGRESS_POSITION,		1,
	position_0x
/* *INDENT-ON* */
};

int
x1f4_pass_lxvery(void *lxvery, struct x1f4_progress_type **progress,
		 char **copy)
{
    int type;
    struct x1f4_progress_type *progress_data;

    type = ((struct lxvery_type *) lxvery)->link_t.datatype[0].type;

    progress_data = *progress;

    *progress_data = progress_0f;
    progress_data->type = type;
    progress_data++;

    *progress_data = progress_0b;
    progress_data->type = type;
    progress_data++;

    *progress = progress_data;

    return 0;
}
