/*
 * lxvery-inter.h
 * Copyright (C) 2008-2019, 2021, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxvery_inter_H__
#define __LIBx1f4_lxvery_inter_H__

#include <cl.h>
#include <dt.h>
#include <e4.h>
#include <lxvery-types.h>
#include <lxwide.h>
#include <nt.h>
#include <progress.h>
#include <trans.h>

#define _libx1f4i0_lxvery_bset_line	x1f4_bset_lxvery
#define _libx1f4i0_lxvery_clip_line	x1f4_clip_lxvery
#define _libx1f4i0_lxvery_copy_line	x1f4_copy_lxvery
#define _libx1f4i0_lxvery_deck_line	x1f4_deck_lxvery
#define _libx1f4i0_lxvery_dset_line	x1f4_dset_lxvery
#define _libx1f4i0_lxvery_fini_line	x1f4_fini_lxvery
#define _libx1f4i0_lxvery_flat_line	x1f4_flat_lxvery
#define _libx1f4i0_lxvery_fold_line	x1f4_fold_lxvery
#define _libx1f4i0_lxvery_free_line	x1f4_free_lxvery
#define _libx1f4i0_lxvery_fset_line	x1f4_fset_lxvery
#define _libx1f4i0_lxvery_init_line	x1f4_init_lxvery
#define _libx1f4i0_lxvery_lead_line	x1f4_lead_lxvery
#define _libx1f4i0_lxvery_line_line	x1f4_line_lxvery
#define _libx1f4i0_lxvery_link_line	x1f4_link_lxvery
#define _libx1f4i0_lxvery_miss_line	x1f4_miss_lxvery
#define _libx1f4i0_lxvery_near_line	x1f4_near_lxvery
#define _libx1f4i0_lxvery_node_line	x1f4_node_lxvery
#define _libx1f4i0_lxvery_pass_line	x1f4_pass_lxvery
#define _libx1f4i0_lxvery_post_line	x1f4_post_lxvery
#define _libx1f4i0_lxvery_pull_line	x1f4_pull_lxvery
#define _libx1f4i0_lxvery_seek_line	x1f4_seek_lxvery
#define _libx1f4i0_lxvery_slip_line	x1f4_slip_lxvery
#define _libx1f4i0_lxvery_suit_line	x1f4_suit_lxvery
#define _libx1f4i0_lxvery_tile_line	x1f4_tile_lxvery
#define _libx1f4i0_lxvery_tune_line	x1f4_tune_lxvery
#define _libx1f4i0_lxvery_type_line	x1f4_type_lxvery
#define _libx1f4i0_lxvery_uset_line	x1f4_uset_lxvery
#define _libx1f4i0_lxvery_vset_line	x1f4_vset_lxvery

#define _libx1f4i0_lxvery_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_lock((___l)), (___1))
#define _libx1f4i0_lxvery_stat_gear(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_gear(__types_lock((___l)), (___1), (___2))
#define _libx1f4i0_lxvery_stat_land(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_land(__types_lock((___l)), (___1), (___2))
#define _libx1f4i0_lxvery_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_lock((___l)))
#define _libx1f4i0_lxvery_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_lock((___l)))
#define _libx1f4i0_lxvery_stat_roll(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_roll(__types_lock((___l)))
#define _libx1f4i0_lxvery_stat_zero(___l) \
    _libx1f4i0_lxlock_stat_zero(__types_lock((___l)))

extern int _libx1f4i0_lxvery_0k_queued(void *, void *, void **);
extern int _libx1f4i0_lxvery_a_keeping(void *, void *, void **);
extern int _libx1f4i0_lxvery_b_derived(void *, void *, void **);
extern int _libx1f4i0_lxvery_bset_line
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxvery_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxvery_c_pending(void *, void *, void **);
extern int _libx1f4i0_lxvery_cfix_line(void *, unsigned, void *);
extern int _libx1f4i0_lxvery_clip_line
    (unsigned, const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxvery_copy_link(void *, void *, const void *);
extern int _libx1f4i0_lxvery_copy_line
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxvery_copy_text
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxvery_d_logique(void *, void *, void **);
extern int _libx1f4i0_lxvery_dset_line
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxvery_e_pending(void *, void *, void **);
extern int _libx1f4i0_lxvery_f1centric(void *, void *, void **);
extern int _libx1f4i0_lxvery_f_centric(void *, void *, void **);
extern int _libx1f4i0_lxvery_f_derived(void *, void *, void **);
extern int _libx1f4i0_lxvery_fast_line(void *, void *);
extern int _libx1f4i0_lxvery_fini_line(void **);
extern int _libx1f4i0_lxvery_flat_line(void *, void **);
extern int _libx1f4i0_lxvery_fold_line(void *, unsigned *);
extern int _libx1f4i0_lxvery_free_link(void *, void *);
extern int _libx1f4i0_lxvery_free_line
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxvery_free_text
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxvery_fset_line
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxvery_g_keeping(void *, void *, void **);
extern int _libx1f4i0_lxvery_h_keeping(void *, void *, void **);
extern int _libx1f4i0_lxvery_init_line
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxvery_k_logique(void *, void *, void **);
extern int _libx1f4i0_lxvery_keep_call
    (void **, void **, unsigned, int *, const int *, unsigned, int, int, int);
extern int _libx1f4i0_lxvery_lead_line(void *, void **);
extern int _libx1f4i0_lxvery_lead_text(void *, void **);
extern int _libx1f4i0_lxvery_line_line(void *, void **);
extern int _libx1f4i0_lxvery_link_line(void *, void **);
extern int _libx1f4i0_lxvery_m_derived(void *, void *, void **);
extern int _libx1f4i0_lxvery_n_forward(void *, void *, void **);
extern int _libx1f4i0_lxvery_near_line(void *);
extern int _libx1f4i0_lxvery_node_line
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxvery_null_line
    (void *, struct excase_type **, void *);
extern int _libx1f4i0_lxvery_p_forward(void *, void *, void **);
extern int _libx1f4i0_lxvery_pass_line
    (void *, struct x1f4_progress_type **, char **);
extern int _libx1f4i0_lxvery_post_line
    (void *, void **, const struct excase_type *);
extern int _libx1f4i0_lxvery_pull_line
    (void *, void *, void *, const void *, struct trans_type *,
     struct x1f4_caselink_type **);
extern int _libx1f4i0_lxvery_push_text
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxvery_r_centric(void *, void *, void **);
extern int _libx1f4i0_lxvery_r_forward(void *, void *, void **);
extern int _libx1f4i0_lxvery_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxvery_s_pending(void *, void *, void **);
extern int _libx1f4i0_lxvery_s_sequent(void *, void *, void **);
extern int _libx1f4i0_lxvery_seek_line(const void *);
extern int _libx1f4i0_lxvery_side_line(void *, void *);
extern int _libx1f4i0_lxvery_slip_line(void *, void **);
extern int _libx1f4i0_lxvery_slip_text(void *, void **);
extern int _libx1f4i0_lxvery_stat_ever(void *);
extern int _libx1f4i0_lxvery_stat_line(void *, int, int);
extern int _libx1f4i0_lxvery_stat_miss(void *, long);
extern int _libx1f4i0_lxvery_stat_null(void *);
extern int _libx1f4i0_lxvery_stat_post(void *, long);
extern int _libx1f4i0_lxvery_stat_text(void *, int, long);
extern int _libx1f4i0_lxvery_suit_line(void *, void *, void *);
extern int _libx1f4i0_lxvery_swap_line(void *, void *);
extern int _libx1f4i0_lxvery_tile_line
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxvery_tune_line(void *);
extern int _libx1f4i0_lxvery_type_line(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxvery_uset_line
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxvery_v_pending(void *, void *, void **);
extern int _libx1f4i0_lxvery_very_line
    (struct lxrail_type *, struct fydata_type *, void *);

#endif				/* __LIBx1f4_lxvery_inter_H__ */
