/*
 * lxvery-l.c.c
 * Copyright (C) 2008-2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#define dxvery(dxvery) \
    ((struct dxvery_type *) (dxvery))

int
_libx1f4i0_lxvery_c_logique(void *context, void *output, void **input)
{
    int status;
    struct dxvery_type *dxvery_data, *dxvery_text;

    dxvery_data = I_LINE(input[0]);
    dxvery_text = I_LINE(input[1]);

    if (dxvery_data == dxvery_text) {
	status = 0;
    } else {
	void *dxtext;

	status = _libx1f4i0_lxvery_line_line(context, &dxtext);
	if (status) {
	} else {
	    status = _libx1f4i0_line_lxfset
		(dxvery(dxtext)->dash, dxvery_text->dash,
		 _libx1f4i0_lxvery_copy_link, _libx1f4i0_lxvery_free_link,
		 NULL);
	    if (status) {
		status = _libx1f4i0_lxvery_stat_line(context, 0, status);
	    } else {
		dxvery(dxtext)->size = dxvery_text->size;

		status = _libx1f4i0_lxvery_null_line
		    (context, NULL, dxvery_data);
		if (status) {
		} else {
		    status = _libx1f4i0_lxvery_swap_line(dxtext, dxvery_data);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxvery_flat_line(context, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    if (status) {
    } else {
	l_LINE(dxvery_data, output);
    }

    return status;
}
