/*
 * lxvery-p.c.c
 * Copyright (C) 2008-2011, 2013, 2015, 2017, 2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

int
_libx1f4i0_lxvery_c_pending(void *context, void *output, void **input)
{
    int status;
    struct dxvery_type *dxvery_data;

    dxvery_data = I_LINE(input[0]);
    do {
	if (!dxvery_data->size) {
	    status = 0;
	} else {
	    status = _libx1f4i0_lxvery_null_line(context, NULL, dxvery_data);
	    if (status) {
		break;
	    }
	}

	l_LINE(dxvery_data, output);
    } while (0);

    return status;
}
