/*
 * lxxsxx-4.p.c
 * Copyright (C) 2008-2012, 2014, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <string.h>

#include <e4.h>
#include <lxport-drive.h>
#include <lxport-inter.h>
#include <lxport-types.h>

int
_libx1f4i0_lxport_p_4xshell(void *context, void *output, void **input)
{
    int status;
    struct lxport_type *lxport_data;
    struct x1f4_function_type *function_data;
    const struct x1f4_linetext_type *l_append;
    struct xsport_type *xsport_data;
    unsigned count;
    void **strip;

    lxport_data = context;

    xsport_data = I_XSXX(input[0]);

    strip = input[-1];

    function_data = strip[X1f4_E4_RENDITION];

    status = 0;

    l_append = lxport_data->rule_l.l_append;

    count = function_data->count - 1;
    if (count && l_append) {
	void **press;

	press =
	    malloc((count + 2) * sizeof(void *) + (count + 1) * sizeof(int));
	if (press) {
	    int *args;
	    struct x1f4_function_type function;

	    press[0] = strip;
	    press[1] = &xsport_data->argv;
	    memcpy(press + 2, input + 1, count * sizeof(void *));

	    function.args = args = (int *) (press + count + 2);

#if 0
	    args[0] = lxport_data->link_i.list;
#endif				/* 0 */
	    memcpy(args + 1, function_data->args + 1, count * sizeof(int));

	    function.count = count + 1;

	    strip[X1f4_E4_RENDITION] = &function;

	    status = l_append->function.function
		((void *) l_append->context, output, press + 1);

	    free(press);
	} else {
	    status = _libx1f4i0_lxport_stat_link(lxport_data);
	}
    }

    if (status) {
    } else {
	l_XSXX(xsport_data, output);
    }

    return status;
}
