/*
 * mode.0.c
 * Copyright (C) 2006-2010, 2017, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>
#include <stdio.h>

#include <aime.h>
#include <lintegral-x.h>
#include <ordinal.h>

int
libx1f4i0_lead_mode(const char *self, const char *text, unsigned i, void *aime)
{
    int status;
    X1f4_E4_C_MODE *slip;
    long mode;

    status = x1f4_parse_xlintegral(&mode, text, NULL, 0);
    if (status) {
	char sx[3];

	x1f4_extend_ordinal(sx, i);
	sx[2] = 0;
	fprintf(stderr, "%s: cannot parse value specification for %u%s varia"
		"ble: `%s'\n", self, i + 1, sx, text);
    } else {
	status = 0;

	slip = aime;
	*slip = mode;
    }

    return status;
}
